include CPUID.Inc
.code
WinMain proc <5> lpRet:PVOID
	invoke GetModuleHandle,NULL
	mov hInstance,rax
	invoke DialogBoxParam,hInstance,IDD_CPUID,NULL,addr DlgProc,NULL
	invoke ExitProcess,rax
WinMain endp
DlgProc proc <8> uses rsi rdi rbx hWnd:HWND,uMsg:UINT64,wParam:WPARAM,lParam:LPARAM
	mov hWnd,rcx
	mov uMsg,rdx
	mov wParam,r8
	mov lParam,r9
	.if edx==WM_INITDIALOG
		.data?
			VendorId	db 16 dup(?)
			IntVal		dq ?
			fn_eax		dd ?
			fn_ebx		dd ?
			fn_ecx		dd ?
			fn_edx		dd ?
			IntValStr	CHAR 64 dup(?)
		.code
		mov eax,0
		cpuid
		mov dptr VendorId[0],ebx
		mov dptr VendorId[4],edx
		mov dptr VendorId[8],ecx
		mov dptr VendorId[12],0
		mov IntVal,rax
		invoke SetDlgItemText,hWnd,IDC_VENDOR_ID,addr VendorId
		invoke IntToStr,addr IntValStr,addr IntVal,16,STD_HEX
		invoke SetDlgItemText,hWnd,IDC_MAXB_HEX,addr IntValStr
		invoke IntToStr,addr IntValStr,addr IntVal,10,STD_DEC
		invoke SetDlgItemText,hWnd,IDC_MAXB_DEC,addr IntValStr
		mov eax,1
		cpuid
		mov fn_eax,eax
		mov fn_ebx,ebx
		mov fn_ecx,ecx
		mov fn_edx,edx
		shr eax,20
		and eax,0FFh
		mov IntVal,rax
		invoke IntToStr,addr IntValStr,addr IntVal,16,STD_HEX
		invoke SetDlgItemText,hWnd,IDC_EXT_FAMILY_HEX,addr IntValStr
		invoke IntToStr,addr IntValStr,addr IntVal,10,STD_DEC
		invoke SetDlgItemText,hWnd,IDC_EXT_FAMILY_DEC,addr IntValStr
		mov eax,fn_eax
		shr eax,16
		and eax,0Fh
		mov IntVal,rax
		invoke IntToStr,addr IntValStr,addr IntVal,16,STD_HEX
		invoke SetDlgItemText,hWnd,IDC_EXT_MODEL_HEX,addr IntValStr
		invoke IntToStr,addr IntValStr,addr IntVal,10,STD_DEC
		invoke SetDlgItemText,hWnd,IDC_EXT_MODEL_DEC,addr IntValStr
		mov eax,fn_eax
		shr eax,12
		and eax,11y
		.if ~eax
			mov eax,IDC_RBN_OEM_TYPE
		.elseif eax==1
			mov eax,IDC_RBN_OV_TYPE
		.elseif eax==2
			mov eax,IDC_RBN_DUAL_TYPE
		.elseif eax==3
			mov eax,IDC_RBN_RSV_TYPE
		.endif
		invoke SendDlgItemMessage,hWnd,eax,BM_SETCHECK,BST_CHECKED,0
		mov eax,fn_eax
		shr eax,8
		and eax,0Fh
		mov IntVal,rax
		invoke IntToStr,addr IntValStr,addr IntVal,16,STD_HEX
		invoke SetDlgItemText,hWnd,IDC_FAMILY_HEX,addr IntValStr
		invoke IntToStr,addr IntValStr,addr IntVal,10,STD_DEC
		invoke SetDlgItemText,hWnd,IDC_FAMILY_DEC,addr IntValStr
		mov eax,fn_eax
		shr eax,4
		and eax,0Fh
		mov IntVal,rax
		invoke IntToStr,addr IntValStr,addr IntVal,16,STD_HEX
		invoke SetDlgItemText,hWnd,IDC_MODEL_HEX,addr IntValStr
		invoke IntToStr,addr IntValStr,addr IntVal,10,STD_DEC
		invoke SetDlgItemText,hWnd,IDC_MODEL_DEC,addr IntValStr
		mov eax,fn_eax
		and eax,0Fh
		mov IntVal,rax
		invoke IntToStr,addr IntValStr,addr IntVal,16,STD_HEX
		invoke SetDlgItemText,hWnd,IDC_STEPPING_HEX,addr IntValStr
		invoke IntToStr,addr IntValStr,addr IntVal,10,STD_DEC
		invoke SetDlgItemText,hWnd,IDC_STEPPING_DEC,addr IntValStr
		movzx eax,bptr fn_ebx[0]
		mov IntVal,rax
		invoke IntToStr,addr IntValStr,addr IntVal,16,STD_HEX
		invoke SetDlgItemText,hWnd,IDC_BRAND_ID_HEX,addr IntValStr
		invoke IntToStr,addr IntValStr,addr IntVal,10,STD_DEC
		invoke SetDlgItemText,hWnd,IDC_BRAND_ID_DEC,addr IntValStr
		movzx eax,bptr fn_ebx[1]
		mov IntVal,rax
		invoke IntToStr,addr IntValStr,addr IntVal,16,STD_HEX
		invoke SetDlgItemText,hWnd,IDC_LINE_SIZE_HEX,addr IntValStr
		invoke IntToStr,addr IntValStr,addr IntVal,10,STD_DEC
		invoke SetDlgItemText,hWnd,IDC_LINE_SIZE_DEC,addr IntValStr
		movzx eax,bptr fn_ebx[2]
		mov IntVal,rax
		invoke IntToStr,addr IntValStr,addr IntVal,16,STD_HEX
		invoke SetDlgItemText,hWnd,IDC_PROC_COUNT_HEX,addr IntValStr
		invoke IntToStr,addr IntValStr,addr IntVal,10,STD_DEC
		invoke SetDlgItemText,hWnd,IDC_PROC_COUNT_DEC,addr IntValStr
		movzx eax,bptr fn_ebx[3]
		mov IntVal,rax
		invoke IntToStr,addr IntValStr,addr IntVal,16,STD_HEX
		invoke SetDlgItemText,hWnd,IDC_APIC_ID_HEX,addr IntValStr
		invoke IntToStr,addr IntValStr,addr IntVal,10,STD_DEC
		invoke SetDlgItemText,hWnd,IDC_APIC_ID_DEC,addr IntValStr
		.if fn_ecx&(1 shl 0)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_SSE3,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 1)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_PCLMULQDQ,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 2)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_DTES64,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 3)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_MONITOR,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 4)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_DS_CPL,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 5)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_VMX,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 6)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_SMX,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 7)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_EIST,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 8)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_TM2,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 9)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_SSSE3,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 10)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_CNTX_ID,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 12)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_FMA,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 13)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_CMPXCHG16B,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 14)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_XTPR,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 15)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_PDCM,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 17)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_PCID,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 18)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_DCA,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 19)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_SSE41,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 20)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_SSE42,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 21)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_X2APIC,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 22)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_MOVBE,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 23)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_POPCNT,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 24)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_TSC_DEADLINE,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 25)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_AESNI,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 26)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_XSAVE,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 27)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_OSXSAVE,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 28)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_AVX,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_ecx&(1 shl 30)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_RDRAND,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 0)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_FPU,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 1)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_VME,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 2)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_DE,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 3)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_PSE,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 4)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_TSC,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 5)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_MSR,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 6)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_PAE,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 7)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_MCE,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 8)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_CMPXCHG8B,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 9)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_APIC,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 11)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_SYSENTER,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 12)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_MTRR,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 13)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_PGE,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 14)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_MCA,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 15)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_CMOV,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 16)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_PAT,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 17)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_PSE_36,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 18)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_PSN,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 19)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_CLFLUSH,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 21)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_DS,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 22)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_ACPI,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 23)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_MMX,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 24)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_FXSAVE,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 25)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_SSE,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 26)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_SSE2,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 27)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_SS,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 28)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_HTT,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 29)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_TM,BM_SETCHECK,BST_CHECKED,0
		.endif
		.if fn_edx&(1 shl 31)
			invoke SendDlgItemMessage,hWnd,IDC_CHK_PBE,BM_SETCHECK,BST_CHECKED,0
		.endif
	.elseif edx==WM_CLOSE
		invoke EndDialog,hWnd,0
	.else
		return(FALSE)
	.endif
	return(TRUE)
DlgProc endp
end