include 'dsmenums.inc'
include 'idmfasm.inc'
GPR_EAX=0
GPR_EBX=3
GPR_ECX=1
GPR_EDX=2
GPR_ESI=6
GPR_EDI=7
GPR_EBP=5
GPR_ESP=4
GPR_AX=0
GPR_BX=3
GPR_CX=1
GPR_DX=2
GPR_SI=6
GPR_DI=7
GPR_BP=5
GPR_SP=4
GPR_AL=0
GPR_BL=3
GPR_CL=1
GPR_DL=2
GPR_AH=4
GPR_BH=7
GPR_CH=5
GPR_DH=6
GPR_RAX=0
GPR_RBX=3
GPR_RCX=1
GPR_RDX=2
GPR_RSI=6
GPR_RDI=7
GPR_RBP=5
GPR_RSP=4
GPR_R8=8
GPR_R9=9
GPR_R10=10
GPR_R11=11
GPR_R12=12
GPR_R13=13
GPR_R14=14
GPR_R15=15
GPR_R8d=8
GPR_R9d=9
GPR_R10d=10
GPR_R11d=11
GPR_R12d=12
GPR_R13d=13
GPR_R14d=14
GPR_R15d=15
GPR_R8w=8
GPR_R9w=9
GPR_R10w=10
GPR_R11w=11
GPR_R12w=12
GPR_R13w=13
GPR_R14w=14
GPR_R15w=15
GPR_R8b=8
GPR_R9b=9
GPR_R10b=10
GPR_R11b=11
GPR_R12b=12
GPR_R13b=13
GPR_R14b=14
GPR_R15b=15
GPR_SIL=6
GPR_DIL=7
GPR_BPL=5
GPR_SPL=4
ID_ES=0
ID_CS=1
ID_SS=2
ID_DS=3
ID_FS=4
ID_GS=5
bptr equ byte
wptr equ word
dptr equ dword
qptr equ qword
optr equ dqword
struct Features
	Note		db ?
	ExNote		db ?
	MnemOrd		dw ?
	FirstOper	db ?
	SecondOper	db ?
	ThirdOper	db ?
	FourthOper	db ?
	FifthOper	db ?
	iSet		db ?
ends
LPFeatures equ dq
struct moRange
	HighAddr	dd ?
	LowAddr		dd ?
ends
struct moRanges
	CntRange	dd ?
	rng			moRange<>
ends
pmoRanges equ dq
struct EF
	ID		db ?
	VIP 	db ?
	VIF 	db ?
	AC		db ?
	VM		db ?
	RF		db ?
	NT		db ?
	IOPL	db ?
	_OF		db ?
	_DF		db ?
	_IF		db ?
	TF		db ?
	SF		db ?
	ZF		db ?
	AF		db ?
	PF		db ?
	CF		db ?
ends
LPEF equ dq
struct x87c
	C0	db ?
	C1	db ?
	C2	db ?
	C3	db ?
	dC0	db ?
	dC1	db ?
	dC2	db ?
	dC3	db ?
ends
NA=0
_0=1
_1=2
U=3
_Mod=4
TMod=5
_Pop=6
TPop=7
Tst=8
lAH=9
VMS0=10
VMIN=11
VMEN=12
lmem=1
_rng=2
_ovs=3
v0q=4
v1q=5
v2q=6
fpri=7
rnup=8
fexm=9
_ous=10
cmp0=11
ex00=12
ex01=13
ex02=14
ex03=15
struct X87Exception
	Exception	db ?
	Mnemonic	db 3 dup(?)
	AltMnemonic	db 3 dup(?)
	Flags		db ?
ends 
LPX87Exception equ dq
struct MediaException
	Exception	db ?
	Mnemonic	db 3 dup(?)
	AltMnemonic	db 3 dup(?)
	Flags		db ?
ends
LPMediaException equ dq
IEEE754=(1 shl 3)
NAN_HIGH_PRIORITY=(1 shl 4)
struct ExceptProps
	Interrupt	db ?
	Mnemonic	db 4 dup(?)
	Cause		db ?
	Flags		dw ?
ends
LPExceptProps equ dq
MIN_MODRM=Mb_Rd_q
MAX_MODRM=UnkModRM
struct AltmBytes
	TotalBytes		db ?
	AlterOpcNum		db ?
	OptAddr			db ?
	PfxPerm			db ?
	WasteBitFields	db ?
	WastePfx		db 19 dup(?)
ends
PALTM_BYTES equ dq
MaxInstrLen=15
FULL_OPCSIZE=32
STD_MNEM_SIZE=32
STD_OPERMNEM_SIZE=64
ALTM_STR_SIZE=128
PLAIN_DASM=(MNEM_HEAP or OPER1_HEAP or OPER2_HEAP or OPER3_HEAP or OPER4_HEAP or OPER5_HEAP or RJ_OFFSET)
ANALYSES_AREA=(PLAIN_DASM or SINGLE_DASM)
STD_INSTR=(PLAIN_DASM or MO_RANGES)
EXT_INSTR=(STD_INSTR or ANALYSES_HEAP)
CR_LF=(CR or LF or ALT_MNEM)
STD_MNEM=(CR_LF or OFFSETS_COL or HEX_COL or ALT_MNEM or ADDR_COMPACT)
RIP_REL=(RIP_ADDRS or REL_ADDRS or CR_LF or ALT_MNEM)
STD_CLEAR_MNEM=(NOT_TABBED or ALT_MNEM)
RIP_REL_LF=(RIP_ADDRS or REL_ADDRS or LF or ALT_MNEM)
RIP_REL_FFFF=(RIP_ADDRS or REL_ADDRS or CR_LF or ALT_MNEM or REL_FFFF_ADDRS)
pfx_lock=0
pfx_66=1
pfx_67=2
pfx_seg=3
pfx_f2_f3=4
SIGNED_INT=(1 shl 0)
PLUS_SIGN=(1 shl 1)
RADIX_LETTER=(1 shl 2)
FIRST_CIPHER=(1 shl 3)
STD_HEX=(FIRST_CIPHER or RADIX_LETTER)
STD_BIN=RADIX_LETTER
STD_OCT=RADIX_LETTER
STD_DEC=0
SIGNED_HEX=(FIRST_CIPHER or RADIX_LETTER or SIGNED_INT)
SIGNED_BIN=(SIGNED_INT or RADIX_LETTER)
SIGNED_OCT=(SIGNED_INT or RADIX_LETTER)
SIGNED_DEC=SIGNED_INT
UPPER_CHAR=0DFh
DEFAULT_RADIX=(1 shl 0)
STD_MASM_NUM=(DEFAULT_RADIX or FIRST_CIPHER)
MUST_BE_POSITIVE_OR_ZERO=1
DIVIDE_BY_ZERO=2
MUST_BEGINS_BY_CIPHER=3
OWORD_SIZE=(1 shl 8)
HWORD_SIZE=(1 shl 9)
DHWORD_SIZE=(1 shl 10)
QHWORD_SIZE=(1 shl 11)
INDIRECT_SHIFT_COUNT=(1 shl 12)
ERASE_MASM_QUOTES=(1 shl 13)
STD_MASM_NUM_128=(STD_MASM_NUM or OWORD_SIZE)
SIGNED_128=(SIGNED_INT or OWORD_SIZE)
struct Instruction
	MajorVersa		db ?
	MinorVersa		db ?
	OpcNum			db ?
	OpcTotal		db ?
	DsmCtrl			dd ?
	CodePtr			dq ?
	NextPtr			dq ?
	AlterBase		dq ?
	MnemOperType	dq ?
	Mnemonic		dq ?
	Oper1Mnemonic	dq ?
	Oper2Mnemonic	dq ?
	Oper3Mnemonic	dq ?
	Oper4Mnemonic	dq ?
	Oper5Mnemonic	dq ?
	RemnCode		dq ?
	ModrmOffsets	dq ?
	hAnalyses		dq ?
	Mode			db ?
	IsHeapStr		db ?
	FullOpcode		db FULL_OPCSIZE dup(?)
	SegOver			db ?
	RepPfx			db ?
	PfxCnt			db ?
	union
		RexPfx	db ?
		XopRex	db ?
		VexRex	db ?
	ends
	union
		XopSec	db ?
		VexSec	db ?
	ends
	InstrLen		db ?
	mode			db ?
	reg				db ?
	rmem			db ?
	Scale			db ?
	Index			db ?
	Base			db ?
	ModRmAddress	db 32 dup(?)
	DefaultOperSize	db ?
	DefaultAddrSize	db ?
	iFlags			dq ?
	x87Condition	x87c<>
	mOffset			dd ?
	iMxcsr			dd ? 
	DataSegMnem		dd ?
	Status			dd ?
	AddrBias		dd ?
	Opflags			dd ?
	OpFeatures		Features<>
	OptAddr			db ?
	union
		RipOffsetBuf	db 37 dup(?)
		JAddrOffsetBuf	db 37 dup(?)
	ends
	union
		RipOffset	dq ?
		JAddrOffset	dq ?
	ends
	fn1_eax			dd ?
	fn1_ebx			dd ?
	fn1_ecx			dd ?
	fn1_edx			dd ?
	fn7_eax			dd ?
	fn7_ebx			dd ?
	fn7_ecx			dd ?
	fn7_edx			dd ?
	fn80000001_eax	dd ?
	fn80000001_ebx	dd ?
	fn80000001_ecx	dd ?
	fn80000001_edx	dd ?
	InitialCodePtr	dq ?
	InitialCodeSize	dq ?
ends
HINSTR equ dq
struct Analyses
	Analyzand		dq ?
	AnalysesArea	dq ?
	AltmMnemonic	db ALTM_STR_SIZE dup(?)
	AlterOpc		db ?
	PfxPerm			db ?
	WastePfx		db 14 dup(?)
	WasteBitFields	db ?
	LegacyCnt		db 7 dup(?)
ends
HANALYSES equ dq
struct ExceptionPtr
	Vector		db ?
	Flags		db ?
	NoteIndex	dw ?
ends
PEXCEPT_PTR equ dq
struct Exceptions
	eCount		dw ?
	VectorsList	ExceptionPtr<>
ends
PEXCEPTS equ dq
E_REAL=(1 shl 3)
E_8086=(1 shl 4)
E_PR86=(1 shl 5)
E_COMP=(1 shl 6)
E_PR64=(1 shl 7)
E_PROT=(E_PR86 or E_PR64 or E_COMP)
E_ALL=(E_REAL or E_8086 or E_PROT)
E_VPRT=(E_8086 or E_PROT)
E_RORV=(E_REAL or E_8086)
E_NVRT=(E_REAL or E_PROT)
E_NORL=(E_PROT or E_8086)
E_PR32=(E_COMP or E_PR86)
LAT_IMM=(1 shl 0)
LAT_RNG=(1 shl 1)
LNOTE11=(1 shl 2)
LAT_COND=(1 shl 3)
LAT_UNV=(1 shl 4)
LAT_FRACT=(1 shl 5)
LNOTE1=(1 shl 6)
LNOTE2=(1 shl 7)
LNOTE3=(1 shl 8)
LNOTE4=(1 shl 9)
LNOTE5=(1 shl 10)
LNOTE6=(1 shl 11)
LNOTE7=(1 shl 12)
LNOTE8=(1 shl 13)
OPS16=(1 shl 14)
OPS32=(1 shl 15)
OPS64=(1 shl 16)
LNOTE10=(1 shl 17)
LNOTE12=(1 shl 18)
TWO_0F=(1 shl 19)
RA2C=(1 shl 20)
RA4C=(1 shl 21)
BF_EX1_PIPE=(1 shl 22)
LNOTE15=(1 shl 23)
LNOTE14=(1 shl 24)
MODE64=(1 shl 25)
ADDR16=(1 shl 26)
ADDR32=(1 shl 27)
LNOTE13=(1 shl 28)
LNOTE9=(1 shl 29)
NORES=(LNOTE5)
LNOTE16=(1 shl 30)
J32NOF=(1 shl 31)
MODREGREG=(1 shl 0)
MODREGMEM=(1 shl 1)
LNOTE17=(1 shl 2)
LNOTE18=(1 shl 3)
LNOTE19=(1 shl 4)
MBL=(1 shl 6)
VEX_SEC66=(1 shl 7)
EX0_PIPE=(1 shl 0)
EX1_PIPE=(1 shl 1)
AG0_PIPE=(1 shl 2)
AG1_PIPE=(1 shl 3)
P0_PIPE=(1 shl 4)
P1_PIPE=(1 shl 5)
P2_PIPE=(1 shl 6)
P3_PIPE=(1 shl 7)
UNV_PIPE=(1 shl 8)
MAL_PIPE=(1 shl 9)
XBR_PIPE=(1 shl 10)
FMA_PIPE=(1 shl 11)
MC_PIPE=(1 shl 12)
CVT_PIPE=(1 shl 13)
MMA_PIPE=(1 shl 14)
STO_PIPE=(1 shl 15)
FADD_PIPE=(1 shl 16)
FMUL_PIPE=(1 shl 17)
FSTORE_PIPE=(1 shl 18)
NONE_PIPE=(1 shl 19)
EX0_EX1=(EX0_PIPE or EX1_PIPE)
AG0_AG1=(AG0_PIPE or AG1_PIPE)
EX_AG01=(EX0_EX1 or AG0_AG1)
FADD_FMUL=(FADD_PIPE or FMUL_PIPE)
FADD_MUL_ST=(FADD_FMUL or FSTORE_PIPE)
XBR_P1=(XBR_PIPE or P1_PIPE)
MAL_P2_P3=(MAL_PIPE or P2_PIPE or P3_PIPE)
CVT_P0=(CVT_PIPE or P0_PIPE)
STO_P3=(STO_PIPE or P3_PIPE)
FMA_P0_P1=(FMA_PIPE or P0_PIPE or P1_PIPE)
MMA_P0=(MMA_PIPE or P0_PIPE)
FMA_P0=(FMA_PIPE or P0_PIPE)
XBR_P1_FMA_P0=(XBR_P1 or FMA_P0)
FMA_P0_P1_STO_P3=(FMA_P0_P1 or STO_P3)
XBR_P1_CVT_P0=(XBR_P1 or CVT_P0)
CVT_P0_STO_P3=(CVT_P0 or STO_P3)
XBR_P1_STO_P3=(XBR_P1 or STO_P3)
MAL_P2_P3_XBR_P1=(MAL_P2_P3 or XBR_P1)
CVT_P0_FMA_P0_P1=(FMA_P0_P1 or CVT_P0)
DEC_1P=(1 shl 0)
DEC_2P=(1 shl 1)
DEC_VC=(1 shl 2)
DEC_MC=(1 shl 3)
struct ltn
	FirstPfx	db ?
	FirstByte	db ?
	SecondByte	db ?
	ModrmType	db ?
	Pipes		dd ?
	DecodeType	dw ?
	Latency		dq ?
	Latency2	dq ?
	Throughput	dw ?
	Flags		dd ?	
ends
PLTN equ dq
struct ltns
	RelSearch	dd ?
	lCount		dd ?
	Latencies	ltn<>
ends
PLTNS equ dq
LAT_ATHLON=(1 shl 0)
LAT_BULLDOZER=(1 shl 1)
struct cntx
	ReadMemCallback	dq ?
	Context			dq ?
	lpVoid			dq ?
ends
PCNTX equ dq
DIR_FLAG =(1 shl 10)
LZCNT_FLAG=(1 shl 5)
BMI1_FLAG=(1 shl 3)
rbpArg1 	equ qptr [rbp-StackFrame+0*8]
rbpArg2 	equ qptr [rbp-StackFrame+1*8]
rbpArg3 	equ qptr [rbp-StackFrame+2*8]
rbpArg4 	equ qptr [rbp-StackFrame+3*8]
rbpArg5 	equ qptr [rbp-StackFrame+4*8]
rbpArg6 	equ qptr [rbp-StackFrame+5*8]
rbpArg7 	equ qptr [rbp-StackFrame+6*8]
rbpArg8 	equ qptr [rbp-StackFrame+7*8]
rbpArg9		equ qptr [rbp-StackFrame+8*8]
rbpArg10	equ qptr [rbp-StackFrame+9*8]
rbpArg11	equ qptr [rbp-StackFrame+10*8]
rbpArg12	equ qptr [rbp-StackFrame+11*8]
rbpArg13	equ qptr [rbp-StackFrame+12*8]
rbpArg14	equ qptr [rbp-StackFrame+13*8]
rbpParm1	equ qptr [rbp+2*8]
rbpParm2	equ qptr [rbp+3*8]
rbpParm3	equ qptr [rbp+4*8]
rbpParm4	equ qptr [rbp+5*8]
rbpParm5	equ qptr [rbp+6*8]
rbpParm6	equ qptr [rbp+7*8]
rbpParm7	equ qptr [rbp+8*8]
rbpParm8	equ qptr [rbp+9*8]
rbpParm9	equ qptr [rbp+10*8]
rbpParm10	equ qptr [rbp+11*8]
rbpParm11	equ qptr [rbp+12*8]
rbpParm12	equ qptr [rbp+13*8]
rbpParm13	equ qptr [rbp+14*8]
rbpParm14	equ qptr [rbp+15*8]
_rbpArg1 	equ [rbp-StackFrame+0*8]
_rbpArg2 	equ [rbp-StackFrame+1*8]
_rbpArg3 	equ [rbp-StackFrame+2*8]
_rbpArg4 	equ [rbp-StackFrame+3*8]
_rbpArg5 	equ [rbp-StackFrame+4*8]
_rbpArg6 	equ [rbp-StackFrame+5*8]
_rbpArg7 	equ [rbp-StackFrame+6*8]
_rbpArg8 	equ [rbp-StackFrame+7*8]
_rbpArg9	equ [rbp-StackFrame+8*8]
_rbpArg10	equ [rbp-StackFrame+9*8]
_rbpArg11	equ [rbp-StackFrame+10*8]
_rbpArg12	equ [rbp-StackFrame+11*8]
_rbpArg13	equ [rbp-StackFrame+12*8]
_rbpArg14	equ [rbp-StackFrame+13*8]
_rbpParm1	equ [rbp+2*8]
_rbpParm2	equ [rbp+3*8]
_rbpParm3	equ [rbp+4*8]
_rbpParm4	equ [rbp+5*8]
_rbpParm5	equ [rbp+6*8]
_rbpParm6	equ [rbp+7*8]
_rbpParm7	equ [rbp+8*8]
_rbpParm8	equ [rbp+9*8]
_rbpParm9	equ [rbp+10*8]
_rbpParm10	equ [rbp+11*8]
_rbpParm11	equ [rbp+12*8]
_rbpParm12	equ [rbp+13*8]
_rbpParm13	equ [rbp+14*8]
_rbpParm14	equ [rbp+15*8]