;Assembling: mnemgen.asm

id_add=0
id_push=1
id_pop=2
id_or=3
id_adc=4
id_sbb=5
id_and=6
id_daa=7
id_sub=8
id_das=9
id_xor=10
id_aaa=11
id_cmp=12
id_aas=13
id_inc=14
id_dec=15
id_pushad=16
id_pusha=17
id_popad=18
id_popa=19
id_bound=20
id_movsxd=21
id_arpl=22
id_imul=23
id_insb=24
id_insd=25
id_insw=26
id_outsb=27
id_outsd=28
id_outsw=29
id_jo=30
id_jno=31
id_jb=32
id_jnb=33
id_jz=34
id_jnz=35
id_jbe=36
id_ja=37
id_js=38
id_jns=39
id_jp=40
id_jnp=41
id_jl=42
id_jnl=43
id_jle=44
id_jg=45
id_test=46
id_xchg=47
id_mov=48
id_lea=49
id_nop=50
id_pause=51
id_cdqe=52
id_cwde=53
id_cbw=54
id_cqo=55
id_cdq=56
id_cwd=57
id_call=58
id_wait=59
id_pushfq=60
id_pushfd=61
id_pushf=62
id_popfq=63
id_popfd=64
id_popf=65
id_sahf=66
id_lahf=67
id_movsb=68
id_movsq=69
id_movsd=70
id_movsw=71
id_cmpsb=72
id_cmpsq=73
id_cmpsd=74
id_cmpsw=75
id_stosb=76
id_stosq=77
id_stosd=78
id_stosw=79
id_lodsb=80
id_lodsq=81
id_lodsd=82
id_lodsw=83
id_scasb=84
id_scasq=85
id_scasd=86
id_scasw=87
id_retn=88
id_les=89
id_lds=90
id_enter=91
id_leave=92
id_retf=93
id_int3=94
id_int=95
id_into=96
id_iretq=97
id_iretd=98
id_iret=99
id_aam=100
id_aad=101
id_salc=102
id_xlat=103
id_loopz=104
id_loopzd=105
id_loopzw=106
id_jrcxz=107
id_jecxz=108
id_jcxz=109
id_in=110
id_out=111
id_jmp=112
id_int1=113
id_hlt=114
id_cmc=115
id_clc=116
id_stc=117
id_cli=118
id_sti=119
id_cld=120
id_std=121
id_movs=122
id_rol=123
id_ror=124
id_rcl=125
id_rcr=126
id_shl=127
id_shr=128
id_sal=129
id_sar=130
id_not=131
id_neg=132
id_mul=133
id_div=134
id_idiv=135
id_sldt=136
id_str=137
id_lldt=138
id_ltr=139
id_verr=140
id_verw=141
id_sgdt=142
id_sidt=143
id_lgdt=144
id_lidt=145
id_smsw=146
id_lmsw=147
id_invlpg=148
id_swapgs=149
id_rdtscp=150
id_vmrun=151
id_vmmcall=152
id_vmload=153
id_vmsave=154
id_stgi=155
id_clgi=156
id_skinit=157
id_invlpga=158
id_monitor=159
id_mwait=160
id_lfence=161
id_mfence=162
id_sfence=163
id_bt=164
id_bts=165
id_btr=166
id_btc=167
id_cmpxchg16b=168
id_cmpxchg8b=169
id_psrlw=170
id_psraw=171
id_psllw=172
id_psrld=173
id_psrad=174
id_pslld=175
id_psrlq=176
id_psllq=177
id_psrldq=178
id_pslldq=179
id_fxsave64=180
id_fxsave=181
id_ldmxcsr=182
id_stmxcsr=183
id_clflush=184
id_prefetchnta=185
id_prefetcht0=186
id_prefetcht1=187
id_prefetcht2=188
id_extrq=189
id_prefetch=190
id_lar=191
id_lsl=192
id_syscall=193
id_clts=194
id_sysenter=195
id_invd=196
id_wbinvd=197
id_ud2=198
id_femms=199
id_movups=200
id_movss=201
id_movupd=202
id_movlps=203
id_movhlps=204
id_movsldup=205
id_movlpd=206
id_movddup=207
id_unpcklps=208
id_unpcklpd=209
id_unpckhps=210
id_unpckhpd=211
id_movhps=212
id_movlhps=213
id_movshdup=214
id_movhpd=215
id_movaps=216
id_movapd=217
id_cvtpi2ps=218
id_cvtsi2ss=219
id_cvtpi2pd=220
id_cvtsi2sd=221
id_movntps=222
id_movntss=223
id_movntpd=224
id_movntsd=225
id_cvttps2pi=226
id_cvttss2si=227
id_cvttpd2pi=228
id_cvttsd2si=229
id_cvtps2pi=230
id_cvtss2si=231
id_cvtpd2pi=232
id_cvtsd2si=233
id_ucomiss=234
id_ucomisd=235
id_comiss=236
id_comisd=237
id_rdtsc=238
id_wrmsr=239
id_rdmsr=240
id_rdpmc=241
id_sysexitq=242
id_sysexit=243
id_cmovo=244
id_cmovno=245
id_cmovb=246
id_cmovnb=247
id_cmovz=248
id_cmovnz=249
id_cmovbe=250
id_cmova=251
id_cmovs=252
id_cmovns=253
id_cmovp=254
id_cmovnp=255
id_cmovl=256
id_cmovnl=257
id_cmovle=258
id_cmovg=259
id_movmskps=260
id_movmskpd=261
id_sqrtps=262
id_sqrtss=263
id_sqrtpd=264
id_sqrtsd=265
id_rsqrtps=266
id_rsqrtss=267
id_rcpps=268
id_rcpss=269
id_andps=270
id_andpd=271
id_andnps=272
id_andnpd=273
id_orps=274
id_orpd=275
id_xorps=276
id_xorpd=277
id_addps=278
id_addss=279
id_addpd=280
id_addsd=281
id_mulps=282
id_mulss=283
id_mulpd=284
id_mulsd=285
id_cvtps2pd=286
id_cvtss2sd=287
id_cvtpd2ps=288
id_cvtsd2ss=289
id_cvtdq2ps=290
id_cvttps2dq=291
id_cvtps2dq=292
id_subps=293
id_subss=294
id_subpd=295
id_subsd=296
id_minps=297
id_minss=298
id_minpd=299
id_minsd=300
id_divps=301
id_divss=302
id_divpd=303
id_divsd=304
id_maxps=305
id_maxss=306
id_maxpd=307
id_maxsd=308
id_punpcklbw=309
id_punpcklwd=310
id_punpckldq=311
id_packsswb=312
id_pcmpgtb=313
id_pcmpgtw=314
id_pcmpgtd=315
id_packuswb=316
id_punpckhbw=317
id_punpckhwd=318
id_punpckhdq=319
id_packssdw=320
id_punpcklqdq=321
id_punpckhqdq=322
id_movd=323
id_movq=324
id_movdqu=325
id_movdqa=326
id_pshufw=327
id_pshufhw=328
id_pshufd=329
id_pshuflw=330
id_pcmpeqb=331
id_pcmpeqw=332
id_pcmpeqd=333
id_emms=334
id_insertq=335
id_haddpd=336
id_haddps=337
id_hsubpd=338
id_hsubps=339
id_seto=340
id_setno=341
id_setb=342
id_setnb=343
id_setz=344
id_setnz=345
id_setbe=346
id_seta=347
id_sets=348
id_setns=349
id_setp=350
id_setnp=351
id_setl=352
id_setnl=353
id_setle=354
id_setg=355
id_cpuid=356
id_shld=357
id_rsm=358
id_shrd=359
id_cmpxchg=360
id_lss=361
id_lfs=362
id_lgs=363
id_movzx=364
id_popcnt=365
id_bsf=366
id_bsr=367
id_lzcnt=368
id_movsx=369
id_xadd=370
id_cmpps=371
id_cmpss=372
id_cmppd=373
id_movnti=374
id_pinsrw=375
id_pextrw=376
id_shufps=377
id_shufpd=378
id_bswap=379
id_addsubpd=380
id_addsubps=381
id_paddq=382
id_pmullw=383
id_movq2dq=384
id_movdq2q=385
id_pmovmskb=386
id_psubusb=387
id_psubusw=388
id_pminub=389
id_pand=390
id_paddusb=391
id_paddusw=392
id_pmaxub=393
id_pandn=394
id_pavgb=395
id_pavgw=396
id_pmulhuw=397
id_pmulhw=398
id_cvtdq2pd=399
id_cvttpd2dq=400
id_cvtpd2dq=401
id_movntq=402
id_movntdq=403
id_psubsb=404
id_psubsw=405
id_pminsw=406
id_por=407
id_paddsb=408
id_paddsw=409
id_pmaxsw=410
id_pxor=411
id_lddqu=412
id_pmuludq=413
id_pmaddwd=414
id_psadbw=415
id_maskmovq=416
id_maskmovdqu=417
id_psubb=418
id_psubw=419
id_psubd=420
id_psubq=421
id_paddb=422
id_paddw=423
id_paddd=424
id_pfcmpge=425
id_pfmin=426
id_pfrcp=427
id_pfrsqrt=428
id_pfcmpgt=429
id_pfmax=430
id_pfrcpit1=431
id_pfrsqit1=432
id_pfcmpeq=433
id_pfmul=434
id_pfrcpit2=435
id_pmulhrw=436
id_pi2fw=437
id_pi2fd=438
id_pf2iw=439
id_pf2id=440
id_pfnacc=441
id_pfpnacc=442
id_pfsub=443
id_pfadd=444
id_pfsubr=445
id_pfacc=446
id_pswapd=447
id_pavgusb=448
id_fadd=449
id_fmul=450
id_fcom=451
id_fcomp=452
id_fsub=453
id_fsubr=454
id_fdiv=455
id_fdivr=456
id_fld=457
id_fst=458
id_fstp=459
id_fldenv=460
id_fldcw=461
id_fnstenv=462
id_fstenv=463
id_fnstcw=464
id_fstcw=465
id_fxch=466
id_fnop=467
id_fchs=468
id_fld1=469
id_f2xm1=470
id_fprem=471
id_fabs=472
id_fldl2t=473
id_fyl2x=474
id_fyl2xp1=475
id_fldl2e=476
id_fptan=477
id_fsqrt=478
id_fldpi=479
id_fpatan=480
id_fsincos=481
id_ftst=482
id_fldlg2=483
id_fxtract=484
id_frndint=485
id_fxam=486
id_fldln2=487
id_fprem1=488
id_fscale=489
id_fldz=490
id_fdecstp=491
id_fsin=492
id_fincstp=493
id_fcos=494
id_fiadd=495
id_fimul=496
id_ficom=497
id_ficomp=498
id_fisub=499
id_fisubr=500
id_fidiv=501
id_fidivr=502
id_fcmovb=503
id_fcmove=504
id_fcmovbe=505
id_fcmovu=506
id_fucompp=507
id_fild=508
id_fisttp=509
id_fist=510
id_fistp=511
id_fcmovnb=512
id_fcmovne=513
id_fcmovnbe=514
id_fcmovnu=515
id_fucomi=516
id_fcomi=517
id_fnclex=518
id_fclex=519
id_fninit=520
id_finit=521
id_frstor=522
id_fnsave=523
id_fsave=524
id_fnstsw=525
id_fstsw=526
id_ffree=527
id_fucom=528
id_fucomp=529
id_faddp=530
id_fmulp=531
id_fsubrp=532
id_fsubp=533
id_fdivrp=534
id_fdivp=535
id_fcompp=536
id_fbld=537
id_fbstp=538
id_fucomip=539
id_fcomip=540
id_ins=541
id_scas=542
id_outs=543
id_loopnz=544
id_loopnzd=545
id_loopnzw=546
id_loop=547
id_loopd=548
id_loopw=549
id_cmps=550
id_xlatb=551
id_prefetchw=552
id_lods=553
id_stos=554
id_getsec=555
id_retnw=556
id_retnd=557
id_enterw=558
id_enterd=559
id_leavew=560
id_leaved=561
id_vmread=562
id_vmwrite=563
id_vmcall=564
id_vmlaunch=565
id_vmresume=566
id_vmxoff=567
id_vmptrld=568
id_vmptrst=569
id_vmclear=570
id_vmxon=571
id_invept=572
id_invvpid=573
id_xgetbv=574
id_xsetbv=575
id_xsave64=576
id_xsave=577
id_xrstor64=578
id_xrstor=579
id_pshufb=580
id_phaddw=581
id_phaddd=582
id_phaddsw=583
id_pmaddubsw=584
id_phsubw=585
id_phsubd=586
id_phsubsw=587
id_psignb=588
id_psignw=589
id_psignd=590
id_pmulhrsw=591
id_pblendvb=592
id_blendvps=593
id_blendvpd=594
id_ptest=595
id_pabsb=596
id_pabsw=597
id_pabsd=598
id_pmovsxbw=599
id_pmovsxbd=600
id_pmovsxbq=601
id_pmovsxwd=602
id_pmovsxwq=603
id_pmovsxdq=604
id_pmuldq=605
id_pcmpeqq=606
id_movntdqa=607
id_packusdw=608
id_pmovzxbw=609
id_pmovzxbd=610
id_pmovzxbq=611
id_pmovzxwd=612
id_pmovzxwq=613
id_pmovzxdq=614
id_pcmpgtq=615
id_pminsb=616
id_pminsd=617
id_pminuw=618
id_pminud=619
id_pmaxsb=620
id_pmaxsd=621
id_pmaxuw=622
id_pmaxud=623
id_pmulld=624
id_phminposuw=625
id_aesimc=626
id_aesenc=627
id_aesenclast=628
id_aesdec=629
id_aesdeclast=630
id_movbe=631
id_crc32=632
id_roundps=633
id_roundpd=634
id_blendps=635
id_blendpd=636
id_pblendw=637
id_aeskeygenassist=638
id_dpps=639
id_dppd=640
id_mpsadbw=641
id_pclmulqdq=642
id_pcmpestrm=643
id_pcmpestri=644
id_pcmpistrm=645
id_pcmpistri=646
id_roundss=647
id_roundsd=648
id_palignr=649
id_pextrb=650
id_pextrq=651
id_pextrd=652
id_extractps=653
id_pinsrb=654
id_insertps=655
id_pinsrq=656
id_pinsrd=657
id_cmpeqpd=658
id_cmpltpd=659
id_cmplepd=660
id_cmpunordpd=661
id_cmpneqpd=662
id_cmpnltpd=663
id_cmpnlepd=664
id_cmpordpd=665
id_cmpeqps=666
id_cmpltps=667
id_cmpleps=668
id_cmpunordps=669
id_cmpneqps=670
id_cmpnltps=671
id_cmpnleps=672
id_cmpordps=673
id_cmpeqss=674
id_cmpltss=675
id_cmpless=676
id_cmpunordss=677
id_cmpneqss=678
id_cmpnltss=679
id_cmpnless=680
id_cmpordss=681
id_cmpeqsd=682
id_cmpltsd=683
id_cmplesd=684
id_cmpunordsd=685
id_cmpneqsd=686
id_cmpnltsd=687
id_cmpnlesd=688
id_cmpordsd=689
id_fxrstor64=690
id_fxrstor=691
id_jmpe=692
id_retfw=693
id_retfd=694
id_retfq=695
id_vfmaddss=696
id_vfmaddsubpd=697
id_vfmaddsubps=698
id_vfmsubaddpd=699
id_vfmsubaddps=700
id_vfmsubpd=701
id_vfmsubps=702
id_vfmsubsd=703
id_vfmsubss=704
id_vfnmaddpd=705
id_vfnmaddps=706
id_vfnmaddsd=707
id_vfnmaddss=708
id_vfnmsubpd=709
id_vfnmsubps=710
id_vfnmsubsd=711
id_vfnmsubss=712
id_vpermil2pd=713
id_vpermil2ps=714
id_vfmaddpd=715
id_vfmaddps=716
id_vfmaddsd=717
id_vfrczpd=718
id_vfrczps=719
id_vfrczss=720
id_vfrczsd=721
id_vpcmov=722
id_vpcomb=723
id_vpcomltb=724
id_vpcomleb=725
id_vpcomgtb=726
id_vpcomgeb=727
id_vpcomeqb=728
id_vpcomneqb=729
id_vpcomfalseb=730
id_vpcomtrueb=731
id_vpcomd=732
id_vpcomltd=733
id_vpcomled=734
id_vpcomgtd=735
id_vpcomged=736
id_vpcomeqd=737
id_vpcomneqd=738
id_vpcomfalsed=739
id_vpcomtrued=740
id_vpcomq=741
id_vpcomltq=742
id_vpcomleq=743
id_vpcomgtq=744
id_vpcomgeq=745
id_vpcomeqq=746
id_vpcomneqq=747
id_vpcomfalseq=748
id_vpcomtrueq=749
id_vpcomub=750
id_vpcomltub=751
id_vpcomleub=752
id_vpcomgtub=753
id_vpcomgeub=754
id_vpcomequb=755
id_vpcomnequb=756
id_vpcomfalseub=757
id_vpcomtrueub=758
id_vpcomud=759
id_vpcomltud=760
id_vpcomleud=761
id_vpcomgtud=762
id_vpcomgeud=763
id_vpcomequd=764
id_vpcomnequd=765
id_vpcomfalseud=766
id_vpcomtrueud=767
id_vpcomuq=768
id_vpcomltuq=769
id_vpcomleuq=770
id_vpcomgtuq=771
id_vpcomgeuq=772
id_vpcomequq=773
id_vpcomnequq=774
id_vpcomfalseuq=775
id_vpcomtrueuq=776
id_vpcomuw=777
id_vpcomltuw=778
id_vpcomleuw=779
id_vpcomgtuw=780
id_vpcomgeuw=781
id_vpcomequw=782
id_vpcomnequw=783
id_vpcomfalseuw=784
id_vpcomtrueuw=785
id_vpcomw=786
id_vpcomltw=787
id_vpcomlew=788
id_vpcomgtw=789
id_vpcomgew=790
id_vpcomeqw=791
id_vpcomneqw=792
id_vpcomfalsew=793
id_vpcomtruew=794
id_vphaddbw=795
id_vphaddbd=796
id_vphaddbq=797
id_vphadddq=798
id_vphaddubw=799
id_vphaddubd=800
id_vphaddubq=801
id_vphaddudq=802
id_vphadduwd=803
id_vphadduwq=804
id_vphaddwd=805
id_vphaddwq=806
id_vphsubbw=807
id_vphsubdq=808
id_vphsubwd=809
id_vpmacsdd=810
id_vpmacsdqh=811
id_vpmacsdql=812
id_vpmacssdd=813
id_vpmacssdqh=814
id_vpmacssdql=815
id_vpmacsswd=816
id_vpmacssww=817
id_vpmacswd=818
id_vpmacsww=819
id_vpmadcsswd=820
id_vpmadcswd=821
id_vpperm=822
id_vprotb=823
id_vprotd=824
id_vprotq=825
id_vprotw=826
id_vpshab=827
id_vpshad=828
id_vpshaq=829
id_vpshaw=830
id_vpshlb=831
id_vpshld=832
id_vpshlq=833
id_vpshlw=834
id_call64=835
id_jmp64=836
id_vaddpd=837
id_vaddps=838
id_vaddsd=839
id_vaddss=840
id_vaddsubpd=841
id_vaddsubps=842
id_vaesenc=843
id_vaesenclast=844
id_vaesdec=845
id_vaesdeclast=846
id_vaesimc=847
id_vaeskeygenassist=848
id_vandpd=849
id_vandps=850
id_vandnpd=851
id_vandnps=852
id_vblendpd=853
id_vblendps=854
id_vblendvpd=855
id_vblendvps=856
id_vbroadcastss=857
id_vbroadcastsd=858
id_vbroadcastf128=859
id_vcmppd=860
id_vcmpps=861
id_vcmpsd=862
id_vcmpss=863
id_vcomisd=864
id_vcomiss=865
id_vcvtdq2pd=866
id_vcvtdq2ps=867
id_vcvtpd2dq=868
id_vcvtpd2ps=869
id_vcvtps2dq=870
id_vcvtps2pd=871
id_vcvtsd2si=872
id_vcvtsd2ss=873
id_vcvtsi2sd=874
id_vcvtsi2ss=875
id_vcvtss2sd=876
id_vcvtss2si=877
id_vcvttpd2dq=878
id_vcvttps2dq=879
id_vcvttsd2si=880
id_vcvttss2si=881
id_vdivpd=882
id_vdivps=883
id_vdivsd=884
id_vdivss=885
id_vdppd=886
id_vdpps=887
id_vextractf128=888
id_vextractps=889
id_vhaddpd=890
id_vhaddps=891
id_vhsubpd=892
id_vhsubps=893
id_vinsertf128=894
id_vinsertps=895
id_vlddqu=896
id_vldmxcsr=897
id_vmaskmovdqu=898
id_vmaskmovps=899
id_vmaskmovpd=900
id_vmaxpd=901
id_vmaxps=902
id_vmaxsd=903
id_vmaxss=904
id_vminpd=905
id_vminps=906
id_vminsd=907
id_vminss=908
id_vmovapd=909
id_vmovaps=910
id_vmovq=911
id_vmovd=912
id_vmovddup=913
id_vmovdqa=914
id_vmovdqu=915
id_vmovlps=916
id_vmovhlps=917
id_vmovhps=918
id_vmovlhps=919
id_vmovlpd=920
id_vmovhpd=921
id_vmovmskpd=922
id_vmovmskps=923
id_vmovntdq=924
id_vmovntdqa=925
id_vmovntpd=926
id_vmovntps=927
id_vmovsd=928
id_vmovshdup=929
id_vmovsldup=930
id_vmovss=931
id_vmovupd=932
id_vmovups=933
id_vmpsadbw=934
id_vmulpd=935
id_vmulps=936
id_vmulsd=937
id_vmulss=938
id_vorpd=939
id_vorps=940
id_vpabsb=941
id_vpabsw=942
id_vpabsd=943
id_vpacksswb=944
id_vpackssdw=945
id_vpackuswb=946
id_vpackusdw=947
id_vpaddb=948
id_vpaddw=949
id_vpaddd=950
id_vpaddq=951
id_vpaddsb=952
id_vpaddsw=953
id_vpaddusb=954
id_vpaddusw=955
id_vpalignr=956
id_vpand=957
id_vpandn=958
id_vpavgb=959
id_vpavgw=960
id_vpblendvb=961
id_vpblendw=962
id_vpclmulqdq=963
id_vpcmpestri=964
id_vpcmpestrm=965
id_vpcmpistri=966
id_vpcmpistrm=967
id_vpcmpeqb=968
id_vpcmpeqw=969
id_vpcmpeqd=970
id_vpcmpeqq=971
id_vpcmpgtb=972
id_vpcmpgtw=973
id_vpcmpgtd=974
id_vpcmpgtq=975
id_vpermilpd=976
id_vpermilps=977
id_vperm2f128=978
id_vpextrb=979
id_vpextrw=980
id_vphaddw=981
id_vphaddd=982
id_vphaddsw=983
id_vphminposuw=984
id_vphsubw=985
id_vphsubd=986
id_vphsubsw=987
id_vpinsrb=988
id_vpinsrw=989
id_vpinsrq=990
id_vpinsrd=991
id_vpmaddwd=992
id_vpmaddubsw=993
id_vpmaxsb=994
id_vpmaxsw=995
id_vpmaxsd=996
id_vpmaxub=997
id_vpmaxuw=998
id_vpmaxud=999
id_vpminsb=1000
id_vpminsw=1001
id_vpminsd=1002
id_vpminub=1003
id_vpminuw=1004
id_vpminud=1005
id_vpmovmskb=1006
id_vpmovsxbw=1007
id_vpmovsxbd=1008
id_vpmovzxbw=1009
id_vpmovzxbd=1010
id_vpmulhuw=1011
id_vpmulhrsw=1012
id_vpmulhw=1013
id_vpmullw=1014
id_vpmulld=1015
id_vpmuludq=1016
id_vpmuldq=1017
id_vpor=1018
id_vpsadbw=1019
id_vpshufb=1020
id_vpshufd=1021
id_vpshufhw=1022
id_vpshuflw=1023
id_vpsignb=1024
id_vpsignw=1025
id_vpsignd=1026
id_vpslldq=1027
id_vpsrldq=1028
id_vpsllw=1029
id_vpslld=1030
id_vpsraw=1031
id_vpsrad=1032
id_vpsrlw=1033
id_vpsrld=1034
id_vptest=1035
id_vtestps=1036
id_vtestpd=1037
id_vpsubb=1038
id_vpsubw=1039
id_vpsubd=1040
id_vpsubq=1041
id_vpsubsb=1042
id_vpsubsw=1043
id_vpsubusb=1044
id_vpsubusw=1045
id_vpunpckhbw=1046
id_vpunpckhwd=1047
id_vpunpckhdq=1048
id_vpunpckhqdq=1049
id_vpunpcklbw=1050
id_vpunpcklwd=1051
id_vpunpckldq=1052
id_vpunpcklqdq=1053
id_vpxor=1054
id_vrcpps=1055
id_vrcpss=1056
id_vrsqrtps=1057
id_vrsqrtss=1058
id_vroundpd=1059
id_vroundps=1060
id_vroundsd=1061
id_vroundss=1062
id_vshufpd=1063
id_vshufps=1064
id_vsqrtpd=1065
id_vsqrtps=1066
id_vsqrtsd=1067
id_vsqrtss=1068
id_vstmxcsr=1069
id_vsubpd=1070
id_vsubps=1071
id_vsubsd=1072
id_vsubss=1073
id_vucomisd=1074
id_vucomiss=1075
id_vunpckhpd=1076
id_vunpckhps=1077
id_vunpcklpd=1078
id_vunpcklps=1079
id_vxorpd=1080
id_vxorps=1081
id_vzeroall=1082
id_vzeroupper=1083
id_vfmadd132pd=1084
id_vfmadd132ps=1085
id_vfmadd213pd=1086
id_vfmadd213ps=1087
id_vfmadd231pd=1088
id_vfmadd231ps=1089
id_vfmadd132sd=1090
id_vfmadd132ss=1091
id_vfmadd213sd=1092
id_vfmadd213ss=1093
id_vfmadd231sd=1094
id_vfmadd231ss=1095
id_vfmaddsub132pd=1096
id_vfmaddsub132ps=1097
id_vfmaddsub213pd=1098
id_vfmaddsub213ps=1099
id_vfmaddsub231pd=1100
id_vfmaddsub231ps=1101
id_vfmsubadd132pd=1102
id_vfmsubadd132ps=1103
id_vfmsubadd213pd=1104
id_vfmsubadd213ps=1105
id_vfmsubadd231pd=1106
id_vfmsubadd231ps=1107
id_vfmsub132pd=1108
id_vfmsub132ps=1109
id_vfmsub213pd=1110
id_vfmsub213ps=1111
id_vfmsub231pd=1112
id_vfmsub231ps=1113
id_vfmsub132sd=1114
id_vfmsub132ss=1115
id_vfmsub213sd=1116
id_vfmsub213ss=1117
id_vfmsub231sd=1118
id_vfmsub231ss=1119
id_vfnmadd132pd=1120
id_vfnmadd132ps=1121
id_vfnmadd213pd=1122
id_vfnmadd213ps=1123
id_vfnmadd231pd=1124
id_vfnmadd231ps=1125
id_vfnmadd132sd=1126
id_vfnmadd132ss=1127
id_vfnmadd213sd=1128
id_vfnmadd213ss=1129
id_vfnmadd231sd=1130
id_vfnmadd231ss=1131
id_vfnmsub132pd=1132
id_vfnmsub132ps=1133
id_vfnmsub213pd=1134
id_vfnmsub213ps=1135
id_vfnmsub231pd=1136
id_vfnmsub231ps=1137
id_vfnmsub132sd=1138
id_vfnmsub132ss=1139
id_vfnmsub213sd=1140
id_vfnmsub213ss=1141
id_vfnmsub231sd=1142
id_vfnmsub231ss=1143
id_vcmpeqpd=1144
id_vcmpltpd=1145
id_vcmplepd=1146
id_vcmpunordpd=1147
id_vcmpneqpd=1148
id_vcmpnltpd=1149
id_vcmpnlepd=1150
id_vcmpordpd=1151
id_vcmpeq_uqpd=1152
id_vcmpnge_uspd=1153
id_vcmpngt_uspd=1154
id_vcmpfalse_oqpd=1155
id_vcmpneq_oqpd=1156
id_vcmpge_ospd=1157
id_vcmpgt_ospd=1158
id_vcmptrue_uqpd=1159
id_vcmpeq_ospd=1160
id_vcmplt_oqpd=1161
id_vcmple_oqpd=1162
id_vcmpunord_spd=1163
id_vcmpneq_uspd=1164
id_vcmpnlt_uqpd=1165
id_vcmpnle_uqpd=1166
id_vcmpord_spd=1167
id_vcmpeq_uspd=1168
id_vcmpnge_uqpd=1169
id_vcmpngt_uqpd=1170
id_vcmpfalse_ospd=1171
id_vcmpneq_ospd=1172
id_vcmpge_oqpd=1173
id_vcmpgt_oqpd=1174
id_vcmptrue_uspd=1175
id_vcmpeqps=1176
id_vcmpltps=1177
id_vcmpleps=1178
id_vcmpunordps=1179
id_vcmpneqps=1180
id_vcmpnltps=1181
id_vcmpnleps=1182
id_vcmpordps=1183
id_vcmpeq_uqps=1184
id_vcmpnge_usps=1185
id_vcmpngt_usps=1186
id_vcmpfalse_oqps=1187
id_vcmpneq_oqps=1188
id_vcmpge_osps=1189
id_vcmpgt_osps=1190
id_vcmptrue_uqps=1191
id_vcmpeq_osps=1192
id_vcmplt_oqps=1193
id_vcmple_oqps=1194
id_vcmpunord_sps=1195
id_vcmpneq_usps=1196
id_vcmpnlt_uqps=1197
id_vcmpnle_uqps=1198
id_vcmpord_sps=1199
id_vcmpeq_usps=1200
id_vcmpnge_uqps=1201
id_vcmpngt_uqps=1202
id_vcmpfalse_osps=1203
id_vcmpneq_osps=1204
id_vcmpge_oqps=1205
id_vcmpgt_oqps=1206
id_vcmptrue_usps=1207
id_vcmpeqsd=1208
id_vcmpltsd=1209
id_vcmplesd=1210
id_vcmpunordsd=1211
id_vcmpneqsd=1212
id_vcmpnltsd=1213
id_vcmpnlesd=1214
id_vcmpordsd=1215
id_vcmpeq_uqsd=1216
id_vcmpnge_ussd=1217
id_vcmpngt_ussd=1218
id_vcmpfalse_oqsd=1219
id_vcmpneq_oqsd=1220
id_vcmpge_ossd=1221
id_vcmpgt_ossd=1222
id_vcmptrue_uqsd=1223
id_vcmpeq_ossd=1224
id_vcmplt_oqsd=1225
id_vcmple_oqsd=1226
id_vcmpunord_ssd=1227
id_vcmpneq_ussd=1228
id_vcmpnlt_uqsd=1229
id_vcmpnle_uqsd=1230
id_vcmpord_ssd=1231
id_vcmpeq_ussd=1232
id_vcmpnge_uqsd=1233
id_vcmpngt_uqsd=1234
id_vcmpfalse_ossd=1235
id_vcmpneq_ossd=1236
id_vcmpge_oqsd=1237
id_vcmpgt_oqsd=1238
id_vcmptrue_ussd=1239
id_vcmpeqss=1240
id_vcmpltss=1241
id_vcmpless=1242
id_vcmpunordss=1243
id_vcmpneqss=1244
id_vcmpnltss=1245
id_vcmpnless=1246
id_vcmpordss=1247
id_vcmpeq_uqss=1248
id_vcmpnge_usss=1249
id_vcmpngt_usss=1250
id_vcmpfalse_oqss=1251
id_vcmpneq_oqss=1252
id_vcmpge_osss=1253
id_vcmpgt_osss=1254
id_vcmptrue_uqss=1255
id_vcmpeq_osss=1256
id_vcmplt_oqss=1257
id_vcmple_oqss=1258
id_vcmpunord_sss=1259
id_vcmpneq_usss=1260
id_vcmpnlt_uqss=1261
id_vcmpnle_uqss=1262
id_vcmpord_sss=1263
id_vcmpeq_usss=1264
id_vcmpnge_uqss=1265
id_vcmpngt_uqss=1266
id_vcmpfalse_osss=1267
id_vcmpneq_osss=1268
id_vcmpge_oqss=1269
id_vcmpgt_oqss=1270
id_vcmptrue_usss=1271
id_vpclmullqlqdq=1272
id_vpclmulhqlqdq=1273
id_vpclmullqhdq=1274
id_vpclmulhqhdq=1275
id_pclmullqlqdq=1276
id_pclmulhqlqdq=1277
id_pclmullqhdq=1278
id_pclmulhqhdq=1279
id_ffreep=1280
id_fneni=1281
id_feni=1282
id_fndisi=1283
id_fdisi=1284
id_fnsetpm=1285
id_fsetpm=1286
id_frstpm=1287
id_fsaved=1288
id_fsavew=1289
id_fnsaved=1290
id_fnsavew=1291
id_frstord=1292
id_frstorw=1293
id_fldenvd=1294
id_fldenvw=1295
id_fstenvd=1296
id_fstenvw=1297
id_fnstenvd=1298
id_fnstenvw=1299
id_vpsllq=1300
id_vpsrlq=1301
id_vpmovzxbq=1302
id_vpmovzxdq=1303
id_vpmovzxwd=1304
id_vpmovzxwq=1305
id_vpmovsxbq=1306
id_vpmovsxdq=1307
id_vpmovsxwd=1308
id_vpmovsxwq=1309
id_vpextrq=1310
id_vpextrd=1311
id_xsaveopt64=1312
id_xsaveopt=1313
id_sysretq=1314
id_sysret=1315
id_loadall286=1316
id_loadall386=1317
id_rdfsbase=1318
id_rdgsbase=1319
id_rdrand=1320
id_wrfsbase=1321
id_wrgsbase=1322
id_vcvtph2ps=1323
id_vcvtps2ph=1324
id_andn=1325
id_bextr=1326
id_blsi=1327
id_blsmsk=1328
id_blsr=1329
id_bzhi=1330
id_mulx=1331
id_pdep=1332
id_pext=1333
id_rorx=1334
id_sarx=1335
id_shlx=1336
id_shrx=1337
id_tzcnt=1338
id_invpcid=1339
id_vpblendd=1340
id_vpbroadcastb=1341
id_vpbroadcastw=1342
id_vpbroadcastd=1343
id_vpbroadcastq=1344
id_vbroadcasti128=1345
id_vpmaskmovq=1346
id_vpmaskmovd=1347
id_vpsllvq=1348
id_vpsllvd=1349
id_vpsravd=1350
id_vpsrlvq=1351
id_vpsrlvd=1352
id_vpermps=1353
id_vpermd=1354
id_vinserti128=1355
id_vextracti128=1356
id_vperm2i128=1357
id_vpermpd=1358
id_vpermq=1359
id_vgatherdpd=1360
id_vgatherdps=1361
id_vgatherqpd=1362
id_vgatherqps=1363
id_vpgatherdq=1364
id_vpgatherdd=1365
id_vpgatherqq=1366
id_vpgatherqd=1367
id_blcfill=1368
id_blci=1369
id_blcic=1370
id_blcmsk=1371
id_blcs=1372
id_blsfill=1373
id_blsic=1374
id_t1mskc=1375
id_tzmsk=1376
