include dsbtest.inc
.const
	iccs INITCOMMONCONTROLSEX<sizeof INITCOMMONCONTROLSEX,ICC_WIN95_CLASSES>
	shell32		db 'shell32.dll',0
	ClassName	db "Data Base Explorer Window",0
	AboutClassName db "About Window",0
	InputClassName db "Input Window",0
	AppName		db "Data Base Explorer",0
	EDT_STYLE equ (WS_CHILD or WS_VISIBLE or ES_MULTILINE or WS_VSCROLL or WS_HSCROLL or ES_NOHIDESEL)
	SlateGray		equ 908070h
	align 8
	lBrush		LOGBRUSH<BS_SOLID,SlateGray,HS_VERTICAL or HS_HORIZONTAL>
	align 8
	lfFont	LABEL LOGFONT
		lfHeight		dd -13
		lfWidth			dd 0
		lfEscapement	dd 0
		lfOrientation	dd 0
		lfWeight		dd 190h
		lfItalic		db FALSE
		lfUnderline		db FALSE
		lfStrikeOut		db FALSE
		lfCharSet		db RUSSIAN_CHARSET
		lfOutPrecision	db OUT_STRING_PRECIS
		lfClipPrecision	db CLIP_STROKE_PRECIS
		lfQuality		db DRAFT_QUALITY
		lfPitchAndFamily	db FIXED_PITCH or FF_ROMAN
		lfFaceName			db 'Courier New',0
		db LF_FACESIZE-sizeof lfFaceName dup(0)
	_TriplePoint db "...",0
	TriplePoint equ <addr _TriplePoint>
	dstr button,  edit,static,SysListView32,COMBOBOX
	TestDsb db "test.dsb",0
.data?
	hInstance	HMODULE ?
	hShell		HMODULE ?
	hCourier	HFONT ?
	hBrush		HBRUSH ?
	hListView	HWND ?
	hIcon		HICON ?
	hmMenu		HMENU ?
	hGoButton	HWND ?
	hButton2	HWND ?
	hButtonCmp	HWND ?
	hCboAddress	HWND ?
	hEdit2		HWND ?
	hEdtOffset	HWND ?
	hEditF1		HWND ?
	hEditF2		HWND ?
	hStatic		HWND ?
	hStatic2	HWND ?
	hMainWnd	HWND ?
	hHeap		HANDLE ?
	IdIconNormal	DWORD ?
	IdIconSmall		DWORD ?
	
	hBase1		HDBASE ?
	MainClass	ATOM ?
	AboutClass	ATOM ?
	InputClass	ATOM ?
.code

ALIAS <WinMainCRTStartup>=<WinMain>
WinMain proc <12>
LOCAL msg:MSG
	xor ebx,ebx
	invoke InitCommonControlsEx,addr iccs
	call InitRegData
	invoke GetModuleHandle,ebx
	mov hInstance,rax
	invoke GetProcessHeap
	mov hHeap,rax
	invoke GetModuleHandle,addr shell32
	.if ~rax
		invoke LoadLibrary,addr shell32
	.endif
	mov hShell,rax
	invoke LoadIcon,hShell,SIID_FOLDEROPEN
	mov hIcon,rax
	invoke CreateFontIndirect,addr lfFont
	mov hCourier,rax
	invoke CreateBrushIndirect,addr lBrush
	mov hBrush,rax
	
	invoke RegClassEx,addr AboutClassName,0,addr AboutWndProc,COLOR_BTNFACE+1,hIcon
	mov AboutClass,ax
	invoke RegClassEx,addr InputClassName,0,addr InputWndProc,COLOR_BTNFACE+1,hIcon
	mov InputClass,ax
	invoke RegClassEx,addr ClassName,0,addr WndProc,hBrush,hIcon
	mov MainClass,ax
	mov r10d,CW_USEDEFAULT
	invoke CreateWindowEx,ebx,MainClass,addr AppName,WS_OVERLAPPEDWINDOW or WS_VISIBLE or WS_CLIPCHILDREN,\
		r10,r10,1010,550,rbx,rbx,hInstance,rbx
	lea rdi,msg
	.while TRUE
		invoke GetMessage,rdi,ebx,ebx,ebx
		.break .if ~eax
		invoke TranslateMessage,rdi
		invoke DispatchMessage,rdi
	.endw
	invoke CloseDataBase,hBase1
	invoke UnregisterClass,MainClass,hInstance
	invoke UnregisterClass,AboutClass,hInstance
	invoke UnregisterClass,InputClass,hInstance
	invoke ExitProcess,0
WinMain endp
MakeItem macro ____hMenu:REQ,____ItemID:REQ,____ItemPos:REQ,mi_string:REQ
	mov mii.wID,____ItemID
%	IFIDN <mi_string>,<0>
		mov mii.dwTypeData,0
	ELSE
		lea rax,mi_string
		mov mii.dwTypeData,rax
	ENDIF
	invoke InsertMenuItem,____hMenu,____ItemPos,TRUE,addr mii
endm
MakeSeparator macro ____hMenu:REQ,____ItemPos:REQ
	xor mii.fType,MFT_SEPARATOR
	MakeItem ____hMenu,-1,____ItemPos,0
	xor mii.fType,MFT_SEPARATOR
endm
curr_id=0
enum IDM_FILE,IDM_NEW,IDM_OPEN,IDM_SAVE_AS,IDM_CLOSE,IDM_EXIT
enum IDM_EDIT,IDM_OPEN_OBJ,IDM_NEW_DIR,IDM_NEW_FILE,IDM_RENAME,IDM_DELETE,IDM_CREATE_ROOT,IDM_PACK,IDM_EXTRACT
enum IDM_HELP,IDM_ABOUT

misFile db 'File',0
misNew	db 'New',0
misOpen db 'Open',0
misSaveAs db 'Save As',0
misClose db 'Close',0
misExit db 'Exit',0
misEdit db 'Edit',0
misNewDir db 'New Directory',0
misOpenObj db 'Open Object',0
misNewFile db 'New File',0
misRename db 'Rename',0
misDelete db 'Delete',0
misCreateRoot db 'Create Root Dir',0
misPack db 'Pack File',0
misExtract db 'Extract File',0
misHelp db 'Help',0
misAbout db 'About',0
MakeMenu proc <4> hWnd:HWND
LOCAL hMenu:HMENU
LOCAL mii:MENUITEMINFO
	mov hWnd,rcx
	invoke CreateMenu
	mov hMenu,rax
	invoke SetMenu,hWnd,hMenu
	mov mii.cbSize,sizeof mii
	mov mii.fMask,MIIM_FTYPE or MIIM_ID or MIIM_SUBMENU or MIIM_STRING or MIIM_STATE
	mov mii.fType,MFT_STRING
	mov mii.fState,MFS_ENABLED
	mov rax,hMenu
	mov mii.hSubMenu,rax
	mov mii.hbmpChecked,0
	mov mii.hbmpUnchecked,0
	mov mii.dwItemData,0
	mov mii.cch,0
	mov mii.hbmpItem,0
	MakeItem hMenu,IDM_FILE,0,misFile
	MakeItem hMenu,IDM_EDIT,1,misEdit
	MakeItem hMenu,IDM_HELP,2,misHelp
	invoke GetSubMenu,hMenu,0
	mov rbx,rax
	mov mii.hSubMenu,0
	MakeItem rbx,IDM_NEW,0,misNew
	MakeItem rbx,IDM_OPEN,1,misOpen
	mov mii.fState,MFS_DISABLED
	MakeItem rbx,IDM_SAVE_AS,2,misSaveAs
	MakeItem rbx,IDM_CLOSE,3,misClose
	MakeSeparator rbx,4
	mov mii.fState,MFS_ENABLED
	MakeItem rbx,IDM_EXIT,5,misExit
	invoke GetSubMenu,hMenu,1
	mov rbx,rax
	mov mii.fState,MFS_DISABLED
	MakeItem rbx,IDM_OPEN_OBJ,0,misOpenObj
	MakeItem rbx,IDM_NEW_DIR,1,misNewDir
	MakeItem rbx,IDM_NEW_FILE,2,misNewFile
	mov mii.fState,MFS_ENABLED
	MakeItem rbx,IDM_RENAME,3,misRename
	MakeItem rbx,IDM_DELETE,4,misDelete
	MakeSeparator rbx,5
	;mov mii.fState,MFS_ENABLED
	MakeItem rbx,IDM_CREATE_ROOT,6,misCreateRoot
	MakeSeparator rbx,7
	MakeItem rbx,IDM_PACK,8,misPack
	MakeItem rbx,IDM_EXTRACT,9,misExtract
	invoke GetSubMenu,hMenu,2
	mov rbx,rax
	mov mii.fState,MFS_ENABLED
	MakeItem rbx,IDM_ABOUT,0,misAbout
	invoke DrawMenuBar,hWnd
	return(hMenu)
MakeMenu endp
__Go db '-->Go',0
WndProc proc <12> hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	mov hWnd,rcx
	mov uMsg,edx
	mov wParam,r8
	mov lParam,r9
	.if edx==WM_CREATE
		mov hMainWnd,rcx
		invoke MakeMenu,hWnd
		invoke CreateWindowEx,0,SysListView32,0,WS_VISIBLE or WS_CHILD or LVS_REPORT or LVS_EDITLABELS,\
			300,55,700,430,hWnd,0,hInstance,0
		mov hListView,rax
		invoke SendMessage,hListView,WM_SETFONT,hCourier,TRUE
		invoke CreateDataBase,addr TestDsb,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,0,OPEN_EXISTING,0,0
		mov hBase1,rax
		invoke CreateColumns,hListView
		invoke CreateWindowEx,0,static,"Address:",WS_VISIBLE or WS_CHILD or SS_RIGHT or WS_DISABLED,0,0,75,24,hWnd,0,hInstance,0
		invoke SendMessage,rax,WM_SETFONT,hCourier,TRUE
		invoke CreateWindowEx,0,COMBOBOX,0,\
			WS_VISIBLE or WS_CHILD or WS_TABSTOP or WS_VSCROLL or CBS_DROPDOWN or CBS_HASSTRINGS or CBS_AUTOHSCROLL,\
			75,0,878,96,hWnd,0,hInstance,0
		mov hCboAddress,rax
		invoke SendMessage,hCboAddress,WM_SETFONT,hCourier,TRUE
		invoke CreateWindowEx,0,button,addr __Go,WS_VISIBLE or WS_CHILD or WS_DISABLED,960,0,50,24,hWnd,0,hInstance,0
		mov hGoButton,rax
		invoke SendMessage,hGoButton,WM_SETFONT,hCourier,TRUE
	.elseif edx==WM_SIZE
		invoke MoveCtrls,hWnd,hListView,hGoButton,hCboAddress
	.elseif edx==WM_NOTIFY
		.if NMHDR._code[r9]==NM_DBLCLK
			mov rax,NMHDR.hwndFrom[r9]
			.if rax==hListView
				.if NMITEMACTIVATE.iItem[r9]==-1
					;invoke MessageBox,hWnd,"eeeeeerrrr",0,MB_OK
				.else
					invoke ViewDirContent,hListView,hCboAddress,hBase1,NMITEMACTIVATE.iItem[r9]
				.endif
			.endif
		.elseif NMHDR._code[r9]==NM_RCLICK
			mov rax,NMHDR.hwndFrom[r9]
			.if rax==hListView
;				.if NMITEMACTIVATE.iItem[r9]==-1
;					;invoke MessageBox,hWnd,"eeeeeerrrr",0,MB_OK
;				.else
;					
;				.endif
				invoke TrackPopupL,hWnd,hListView,NMITEMACTIVATE.ptAction[r9]
			.endif
		.elseif NMHDR._code[r9]==LVN_ENDLABELEDIT
			mov rax,r9
			invoke TryRename,hWnd,hListView,hBase1,NMLVDISPINFO.item.iItem[rax],NMLVDISPINFO.item.pszText[rax]
			.if eax
				invoke GetProp,hListView,addr CurrDir
				invoke FillListView,hListView,hCboAddress,hBase1,rax
				mov eax,TRUE
			.endif
			ret
		.elseif NMHDR._code[r9]==LVN_KEYDOWN
			.if NMLVKEYDOWN.wVKey[r9]==VK_DELETE
				invoke DeleteCurrObj,hWnd,hListView,hCboAddress,hBase1
			.endif
		.endif
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.elseif edx==WM_COMMAND
		.if lParam
			.if wptr wParam[2]==BN_CLICKED
				.if r9==hGoButton
					invoke GoToAddress,hListView,hCboAddress,hBase1
					.if ~eax
						invoke MessageBox,hWnd,"Unexisting directory.",addr AppName,MB_ICONHAND
					.endif
				.endif
			.endif
		.else
			.if wptr wParam==IDM_NEW
				invoke NewDataBase,hWnd,hListView
			.elseif wptr wParam==IDM_OPEN
				invoke OpenDataBase,hWnd,hListView
			.elseif wptr wParam==IDM_SAVE_AS
				invoke SaveDataBaseAs,hWnd,hListView
			.elseif wptr wParam==IDM_CLOSE
				invoke CloseDBase,hWnd,hListView
			.elseif wptr wParam==IDM_EXIT
				invoke SendMessage,hWnd,WM_CLOSE,0,0
			.elseif wptr wParam==IDM_EDIT
				invoke MessageBeep,MB_ICONHAND
			.elseif wptr wParam==IDM_NEW_DIR
				invoke MakeNewDir,hWnd,hListView,hCboAddress,hBase1
			.elseif wptr wParam==IDM_NEW_FILE
				invoke MakeNewFile,hWnd,hListView,hCboAddress,hBase1
			.elseif wptr wParam==IDM_CREATE_ROOT
				invoke ShowMakeRootDir,hWnd,hListView
			.elseif wptr wParam==IDM_PACK
				invoke PackFile,hWnd,hListView,hCboAddress,hBase1
			.elseif wptr wParam==IDM_EXTRACT
				invoke ExtractFile,hWnd,hListView,hCboAddress,hBase1
			.elseif wptr wParam==IDM_ABOUT
				invoke ShowAbout,hWnd
			.elseif wptr wParam==IDM_DELETE
				invoke DeleteCurrObj,hWnd,hListView,hCboAddress,hBase1
			.elseif wptr wParam==IDM_RENAME
				invoke EditLabel,hWnd,hListView,hCboAddress,hBase1
			.endif
		.endif
	.elseif edx==WM_MENUCOMMAND
		invoke MessageBeep,MB_ICONHAND
;	.elseif edx==WM_CLOSE
;		invoke MessageBox,hWnd,"Are you want to exit?",addr AppName,MB_ICONQUESTION or MB_YESNO
;		.if eax==IDYES
;			invoke DefWindowProc,hWnd,uMsg,wParam,lParam
;			ret
;		.endif
	.elseif edx==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif
	return(NULL)
WndProc endp
TrackPopupL proc <4> hWnd:HWND,hList:HWND,pt:POINT
LOCAL hMenu:HMENU,hSubMenu1:HMENU
	mov hWnd,rcx
	mov hList,rdx
	mov pt,r8
	invoke GetMenu,hWnd
	mov hMenu,rax
	invoke GetSubMenu,hMenu,1
	mov hSubMenu1,rax
	invoke ClientToScreen,hList,addr pt
	invoke TrackPopupMenuEx,hSubMenu1,TPM_LEFTALIGN or TPM_TOPALIGN,pt.x,pt.y,hWnd,0
	ret
TrackPopupL endp
DeleteCurrObj proc <4> uses rdi hWnd:HWND,hList:HWND,hCbo:HWND,hBase:HDBASE
LOCAL drIndex:ULONG64,obj_index[128]:CHAR,objIndex:ULONG64
LOCAL item:LVITEM
	mov hWnd,rcx
	mov hList,rdx
	mov hCbo,r8
	mov hBase,r9
	invoke GetProp,hList,addr CurrDir
	mov drIndex,rax
	ListView_GetItemCount(hList)
	.if eax
		dec eax
		mov item.imask,LVIF_TEXT or LVIF_STATE
		mov item.iItem,eax
		mov item.iSubItem,0
		mov item.state,0
		mov item.stateMask,LVIS_SELECTED
		lea rax,obj_index
		mov item.pszText,rax
		mov item.cchTextMax,sizeof obj_index
		mov item.iImage,0
		mov item.lParam,0
		mov item.iIndent,0
		mov item.iGroupId,0
		mov item.cColumns,0
		mov item.puColumns,0
		mov item.piColFmt,0
		mov item.iGroup,0
		.repeat
			ListView_GetItem(hList,addr item)
			.if bptr item.state==LVIS_SELECTED
				mov item.iSubItem,1
				ListView_GetItem(hList,addr item)
				invoke StrToInt,addr objIndex,addr obj_index,10,STD_MASM_NUM
				mov item.iSubItem,5
				ListView_GetItem(hList,addr item)
				.if dptr obj_index=='riD'
					invoke DelDirectory,hBase,objIndex,drIndex
				.elseif dptr obj_index=='eliF' && obj_index[4]==0
					invoke DelFile,hBase,objIndex,drIndex
				.endif
				mov item.iSubItem,0
			.endif
			dec item.iItem
		.until SIGN?
	.endif
	invoke FillListView,hList,hCbo,hBase,drIndex
	ret
DeleteCurrObj endp
MakeNewDir proc <5> uses rdi rsi hWnd:HWND,hList:HWND,hCbo:HWND,hBase:HDBASE
LOCAL NewDirName[64]:CHAR,drIndex:ULONG64
	mov hWnd,rcx
	mov hList,rdx
	mov hCbo,r8
	mov hBase,r9
	mov edi,2
	.const
		NewNamePattern db 'New Folder(%u)',0
	.code
	mov dptr NewDirName,' weN'
	mov dptr NewDirName[4],'dloF'
	mov dptr NewDirName[8],'re'
	invoke GetProp,hList,addr CurrDir
	.if rax
		mov rsi,rax
		invoke NewDirectory,hBase,0,0,rsi,addr NewDirName
		.if ~rax
			.while TRUE
				invoke wsprintf,addr NewDirName,addr NewNamePattern,edi
				invoke NewDirectory,hBase,0,0,rsi,addr NewDirName
				.break .if rax
				inc edi
			.endw
		.endif
		mov drIndex,rax
		invoke AddToList,hList,hCbo,hBase,drIndex
		invoke SetFocus,hList
		ListView_GetItemCount(hList)
		dec eax
		ListView_EditLabel(hList,eax)
	.endif
	ret
MakeNewDir endp
MakeNewFile proc <5> uses rdi rsi hWnd:HWND,hList:HWND,hCbo:HWND,hBase:HDBASE
LOCAL NewFileName[64]:CHAR,fIndex:ULONG64
	mov hWnd,rcx
	mov hList,rdx
	mov hCbo,r8
	mov hBase,r9
	mov edi,2
	.const
		NewFNamePattern db 'New File(%u)',0
	.code
	mov dptr NewFileName,' weN'
	mov dptr NewFileName[4],'eliF'
	mov bptr NewFileName[8],0
	invoke GetProp,hList,addr CurrDir
	.if rax
		mov rsi,rax
		invoke NewFile,hBase,0,0,rsi,addr NewFileName
		.if ~rax
			.while TRUE
				invoke wsprintf,addr NewFileName,addr NewFNamePattern,edi
				invoke NewFile,hBase,0,0,rsi,addr NewFileName
				.break .if rax
				inc edi
			.endw
		.endif
		mov fIndex,rax
		invoke AddToList,hList,hCbo,hBase,fIndex
		invoke SetFocus,hList
		ListView_GetItemCount(hList)
		dec eax
		ListView_EditLabel(hList,eax)
	.endif
	ret
MakeNewFile endp
TryRename proc <4> hWnd:HWND,hList:HWND,hBase:HDBASE,ItemID:SDWORD,lpNewName:LPSTR
LOCAL item:LVITEM,objIndex:ULONG64,NameInd:ULONG64
LOCAL obj_index[64]:CHAR
	mov hWnd,rcx
	mov hList,rdx
	mov hBase,r8
	mov ItemID,r9d
	xor eax,eax
	.goto Exit .if ~lpNewName
	mov r9,lpNewName
	.if bptr [r9] && r8d~=-1
		xor r11d,r11d
		.while TRUE
			mov r10b,[r9+r11]
			.break .if ~r10b
			.goto Exit .if r10b=='/' || r10b=='\\'
			inc r11
		.endw
		mov item.imask,LVIF_TEXT
		mov eax,ItemID
		mov item.iItem,eax
		mov item.iSubItem,1
		mov item.state,0
		mov item.stateMask,0
		lea rax,obj_index
		mov item.pszText,rax
		mov item.cchTextMax,sizeof obj_index
		mov item.iImage,0
		mov item.lParam,0
		mov item.iIndent,0
		mov item.iGroupId,0
		mov item.cColumns,0
		mov item.puColumns,0
		mov item.piColFmt,0
		mov item.iGroup,0
		ListView_GetItem(hList,addr item)
		.if eax
			invoke StrToInt,addr objIndex,addr obj_index,10,STD_MASM_NUM
			invoke AddString,hBase,lpNewName,0
			.if rax
				mov NameInd,rax
				invoke RenameObject,hBase,objIndex,0,NameInd
			.endif
		.endif
	.endif
Exit:
	ret
TryRename endp
GoToAddress proc <4> hList:HWND,hCbo:HWND,hBase:HDBASE
LOCAL FullPath[MAX_PATH]:CHAR
	mov hList,rcx
	mov hCbo,rdx
	mov hBase,r8
	invoke SendMessage,hCbo,WM_GETTEXT,sizeof FullPath,addr FullPath
	invoke PathToIndex,hBase,0,addr FullPath
	.if rax
		invoke FillListView,hList,hCbo,hBase,rax
		mov eax,TRUE
	.endif
	ret
GoToAddress endp
ShowAbout proc <12> hWnd:HWND
LOCAL rect:RECT
	mov hWnd,rcx
	invoke GetWindowRect,hWnd,addr rect
	mov qptr rbpArg12,0
	mov rax,hInstance
	mov rbpArg11,rax
	mov qptr rbpArg10,0
	mov rax,hWnd
	mov rbpArg9,rax
	mov rbpArg8,dptr 300
	mov rbpArg7,dptr 400
	mov eax,rect.top
	add eax,50
	mov rbpArg6,eax
	mov eax,rect.left
	add eax,50
	mov rbpArg5,eax
	mov r9d,WS_VISIBLE or WS_POPUPWINDOW or WS_CAPTION
	CONSTANT AboutStr db "About Data Base Explorer",0
	lea r8,AboutStr
	movzx edx,AboutClass
	xor ecx,ecx
	call CreateWindowEx
	ret
ShowAbout endp
host_wnd struc
	hWnd	HWND ?
	hList	HWND ?
	hCbo	HWND ?
	hOK		HWND ?
	hCancel HWND ?
	hEdit	HWND ?
	hBase	HDBASE ?
host_wnd ends
LPHOST_WND TYPEDEF PTR host_wnd
ShowMakeRootDir proc <12> hWnd:HWND,hList:HWND
LOCAL rect:RECT
	mov hWnd,rcx
	mov hList,rdx
	invoke GetWindowRect,hWnd,addr rect
	invoke HeapAlloc,hHeap,0,sizeof host_wnd
	mov rcx,hWnd
	mov rdx,hList
	mov host_wnd.hWnd[rax],rcx
	mov host_wnd.hList[rax],rdx
	mov r8,hBase1
	mov r9,hCboAddress
	mov host_wnd.hBase[rax],r8
	mov host_wnd.hCbo[rax],r9
	mov rbpArg12,rax
	mov rax,hInstance
	mov rbpArg11,rax
	mov qptr rbpArg10,0
	mov rbpArg9,rcx
	mov rbpArg8,dptr 100
	mov rbpArg7,dptr 700
	mov eax,rect.top
	add eax,50+75
	mov rbpArg6,eax
	mov eax,rect.left
	add eax,50
	mov rbpArg5,eax
	mov r9d,WS_VISIBLE or WS_POPUPWINDOW or WS_CAPTION
	CONSTANT InputStr db "Enter a directory name.",0
	lea r8,InputStr
	movzx edx,InputClass
	xor ecx,ecx
	call CreateWindowEx
	ret
ShowMakeRootDir endp
NewDataBase proc <7> hWnd:HWND,hList:HWND
LOCAL NewDBName[MAX_PATH]:CHAR,hBase:HDBASE,hMenu:HMENU
	mov hWnd,rcx
	mov hList,rdx
	invoke SaveFileDialog,hWnd,addr NewDBName,0,0,0
	.if eax
		invoke CreateDataBase,addr NewDBName,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_NEW,0,0
		mov hBase,rax
		.if rax
			invoke SetNewTitle,hWnd,addr NewDBName
			invoke CloseDataBase,hBase1
			mov rax,hBase
			mov hBase1,rax
			ListView_DeleteAllItems(hList)
			invoke GetMenu,hWnd
			mov hMenu,rax
			invoke EnableMenuItem,hMenu,IDM_SAVE_AS,MF_ENABLED
			invoke EnableMenuItem,hMenu,IDM_CLOSE,MF_ENABLED
			invoke EnableMenuItem,hMenu,IDM_CREATE_ROOT,MF_ENABLED
			invoke EnableWindow,hGoButton,TRUE
		.else
			invoke MessageBox,hWnd,"Can`t create data base.",addr AppName,MB_ICONHAND
		.endif
	.endif
	ret
NewDataBase endp
OpenDataBase proc <7> hWnd:HWND,hList:HWND
LOCAL OpenDBName[MAX_PATH]:CHAR,hBase:HDBASE,hMenu:HMENU
	mov hWnd,rcx
	mov hList,rdx
	invoke OpenFileDialog,hWnd,addr OpenDBName,0,0,0
	.if eax
		invoke CreateDataBase,addr OpenDBName,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,0,OPEN_EXISTING,0,0
		mov hBase,rax
		.if rax
			invoke SetNewTitle,hWnd,addr OpenDBName
			invoke CloseDataBase,hBase1
			mov rax,hBase
			mov hBase1,rax
			invoke GetMenu,hWnd
			mov hMenu,rax
			invoke EnableMenuItem,hMenu,IDM_SAVE_AS,MF_ENABLED
			invoke EnableMenuItem,hMenu,IDM_CLOSE,MF_ENABLED
			invoke EnableMenuItem,hMenu,IDM_CREATE_ROOT,MF_ENABLED
			invoke EnableWindow,hGoButton,TRUE
			mov rax,hBase
			mov rax,dsmbase.lpBase[rax]
			.if BASE_HEADER.RootIndex[rax]
				invoke FillListView,hList,hCboAddress,hBase,0
				invoke EnableMenuItem,hMenu,IDM_NEW_DIR,MF_ENABLED
				invoke EnableMenuItem,hMenu,IDM_NEW_FILE,MF_ENABLED
				invoke EnableMenuItem,hMenu,IDM_PACK,MF_ENABLED
				invoke EnableMenuItem,hMenu,IDM_EXTRACT,MF_ENABLED
			.else
				ListView_DeleteAllItems(hList)
			.endif
		.else
			invoke MessageBox,hWnd,"Can`t open a data base.",addr AppName,MB_ICONHAND
		.endif
	.endif
	ret
OpenDataBase endp
PackFile proc <7> hWnd:HWND,hList:HWND,hCbo:HWND,hBase:HDBASE
LOCAL OpenDBName[MAX_PATH]:CHAR,hFile:HMENU,FileSize:ULONG64,hMap:HANDLE,lpFile:PVOID
LOCAL host_ind:ULONG64
	mov hWnd,rcx
	mov hList,rdx
	mov hCbo,r8
	mov hBase,r9
	invoke OpenFileDialog,hWnd,addr OpenDBName,0,0,0
	.if eax
		invoke CreateFile,addr OpenDBName,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,0,0
		.if rax~=INVALID_HANDLE_VALUE
			mov hFile,rax
			invoke GetFileSizeEx,hFile,addr FileSize
			invoke CreateFileMapping,hFile,0,PAGE_READONLY,0,0,0
			mov hMap,rax
			invoke MapViewOfFile,hMap,FILE_MAP_READ,0,0,0
			mov lpFile,rax
			invoke GetProp,hList,addr CurrDir
			mov host_ind,rax
			invoke strrchr,addr OpenDBName,'\\'
			.if ~rax
				lea rax,OpenDBName[-1]
			.endif
			inc rax
			invoke NewFile,hBase,lpFile,FileSize,host_ind,rax
			.if ~rax
				invoke MessageBox,hWnd,"Can`t pack a file.",addr AppName,MB_ICONHAND
			.endif
			invoke UnmapViewOfFile,lpFile
			invoke CloseHandle,hMap
			invoke CloseHandle,hFile
			invoke FillListView,hList,hCbo,hBase,host_ind
		.else
			invoke MessageBox,hWnd,"Can`t open a file.",addr AppName,MB_ICONHAND
		.endif
	.endif
	ret
PackFile endp
ExtractFile proc <7> hWnd:HWND,hList:HWND,hCbo:HWND,hBase:HDBASE
LOCAL SaveDBName[MAX_PATH]:CHAR,hFile:HANDLE
LOCAL drIndex:ULONG64,item:LVITEM,obj_index[128]:CHAR,objIndex:ULONG64
LOCAL ifile:OBJ_INDEX
	mov hWnd,rcx
	mov hList,rdx
	mov hCbo,r8
	mov hBase,r9
	invoke SaveFileDialog,hWnd,addr SaveDBName,0,0,0
	.if eax
		invoke CreateFile,addr SaveDBName,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_NEW,0,0
		.if rax~=INVALID_HANDLE_VALUE
			mov hFile,rax
			invoke GetProp,hList,addr CurrDir
			mov drIndex,rax
			ListView_GetItemCount(hList)
			.if eax
				dec eax
				mov item.imask,LVIF_TEXT or LVIF_STATE
				mov item.iItem,eax
				mov item.iSubItem,0
				mov item.state,0
				mov item.stateMask,LVIS_FOCUSED
				lea rax,obj_index
				mov item.pszText,rax
				mov item.cchTextMax,sizeof obj_index
				mov item.iImage,0
				mov item.lParam,0
				mov item.iIndent,0
				mov item.iGroupId,0
				mov item.cColumns,0
				mov item.puColumns,0
				mov item.piColFmt,0
				mov item.iGroup,0
				.repeat
					ListView_GetItem(hList,addr item)
					.if bptr item.state&LVIS_FOCUSED
						mov item.iSubItem,1
						ListView_GetItem(hList,addr item)
						invoke StrToInt,addr objIndex,addr obj_index,10,STD_MASM_NUM
						mov item.iSubItem,5
						ListView_GetItem(hList,addr item)
						.if dptr obj_index=='eliF' && obj_index[4]==0
							mov rax,objIndex
							mov ifile.Index,rax
							invoke GetIndexType,hBase,addr ifile
							mov rdx,hBase
							mov rdx,dsmbase.lpBase[rdx]
							add rdx,ifile.BaseOffset
							mov r8,ifile.FileSize
							.if r8
								invoke WriteFile,hFile,rdx,r8,addr objIndex,0
							.endif
							invoke CloseHandle,hFile
							jmp Exit
						.endif
						mov item.iSubItem,0
					.endif
					dec item.iItem
				.until SIGN?
			.endif
			invoke MessageBox,hWnd,"No file in focus.",addr AppName,MB_ICONHAND
			invoke CloseHandle,hFile
		.else
			invoke MessageBox,hWnd,"Can`t extract a file.",addr AppName,MB_ICONHAND
		.endif
	.endif
Exit:
	ret
ExtractFile endp
EditLabel proc <7> hWnd:HWND,hList:HWND,hCbo:HWND,hBase:HDBASE
LOCAL drIndex:ULONG64,item:LVITEM,obj_index[128]:CHAR,objIndex:ULONG64
	mov hWnd,rcx
	mov hList,rdx
	mov hCbo,r8
	mov hBase,r9
	invoke GetProp,hList,addr CurrDir
	mov drIndex,rax
	ListView_GetItemCount(hList)
	.if eax
		dec eax
		mov item.imask,LVIF_TEXT or LVIF_STATE
		mov item.iItem,eax
		mov item.iSubItem,0
		mov item.state,0
		mov item.stateMask,LVIS_FOCUSED
		lea rax,obj_index
		mov item.pszText,rax
		mov item.cchTextMax,sizeof obj_index
		mov item.iImage,0
		mov item.lParam,0
		mov item.iIndent,0
		mov item.iGroupId,0
		mov item.cColumns,0
		mov item.puColumns,0
		mov item.piColFmt,0
		mov item.iGroup,0
		.repeat
			ListView_GetItem(hList,addr item)
			.if bptr item.state&LVIS_FOCUSED
				ListView_EditLabel(hList,item.iItem)
				jmp Exit
			.endif
			dec item.iItem
		.until SIGN?
	.endif
Exit:
	ret
EditLabel endp
SetNewTitle proc <4> hWnd:HWND,lpBaseName:LPSTR
LOCAL NewTitle[512]:CHAR
	mov hWnd,rcx
	mov lpBaseName,rdx
	.const
		TitlePattern db '%s [%s]',0
	.code
	invoke wsprintf,addr NewTitle,addr TitlePattern,addr AppName,lpBaseName
	invoke SendMessage,hWnd,WM_SETTEXT,0,addr NewTitle
	ret
SetNewTitle endp
SaveDataBaseAs proc <7> hWnd:HWND,hList:HWND
LOCAL NewDBName[MAX_PATH]:CHAR,hBase:HDBASE
	mov hWnd,rcx
	mov hList,rdx
	invoke SaveFileDialog,hWnd,addr NewDBName,0,0,0
	.if eax
		invoke CreateDataBase,addr NewDBName,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_NEW,0,0
		mov hBase,rax
		.if rax
			mov rdx,hBase1
			mov rdx,dsmbase.BaseSize[rdx]
			invoke IncreaseDataBase,rax,rdx
			mov rdx,hBase1
			mov r8,dsmbase.BaseSize[rdx]
			mov rax,hBase
			mov dsmbase.BaseSize[rax],r8
			invoke memmove,dsmbase.lpBase[rax],dsmbase.lpBase[rdx],r8
			mov rcx,hBase
			xchg rcx,hBase1
			invoke CloseDataBase,rcx
			invoke SetNewTitle,hWnd,addr NewDBName
		.endif
	.endif
	ret
SaveDataBaseAs endp
CloseDBase proc <4> hWnd:HWND,hList:HWND
LOCAL hMenu:HMENU
	mov hWnd,rcx
	mov hList,rdx
	invoke GetMenu,hWnd
	mov hMenu,rax
	invoke EnableMenuItem,hMenu,IDM_SAVE_AS,MF_DISABLED
	invoke EnableMenuItem,hMenu,IDM_CLOSE,MF_DISABLED
	invoke EnableMenuItem,hMenu,IDM_CREATE_ROOT,MF_DISABLED
	invoke EnableWindow,hGoButton,FALSE
	invoke EnableMenuItem,hMenu,IDM_NEW_DIR,MF_DISABLED
	invoke EnableMenuItem,hMenu,IDM_NEW_FILE,MF_DISABLED
	invoke EnableMenuItem,hMenu,IDM_PACK,MF_DISABLED
	invoke EnableMenuItem,hMenu,IDM_EXTRACT,MF_DISABLED
	ListView_DeleteAllItems(hList)
	invoke CloseDataBase,hBase1
	mov hBase1,0
	mov hMenu,0
	invoke SendMessage,hCboAddress,WM_SETTEXT,0,addr hMenu
	invoke SendMessage,hWnd,WM_SETTEXT,0,addr AppName
	ret
CloseDBase endp
hostwnd db 'hostwnd',0
InputWndProc proc <12> hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	mov hWnd,rcx
	mov uMsg,edx
	mov wParam,r8
	mov lParam,r9
	.if edx==WM_CREATE
		mov rax,lParam
		mov r8,CREATESTRUCT.lpCreateParams[rax]
		invoke SetProp,hWnd,addr hostwnd,r8
		mov rax,lParam
		invoke PutInputCtrls,hWnd,CREATESTRUCT.lpCreateParams[rax]
	.elseif (edx==WM_COMMAND && lParam && wptr wParam[2]==BN_CLICKED)
		invoke GetProp,hWnd,addr hostwnd
		mov rdx,lParam
		.if rdx==host_wnd.hOK[rax]
			mov lParam,rax
			invoke CreateRootDir,host_wnd.hEdit[rax],host_wnd.hBase[rax]
			.if rax
				mov r8,rax
				mov rax,lParam
				invoke FillListView,host_wnd.hList[rax],host_wnd.hCbo[rax],host_wnd.hBase[rax],0
				mov rax,lParam
				invoke GetMenu,host_wnd.hWnd[rax]
				mov wParam,rax
				invoke EnableMenuItem,wParam,IDM_NEW_DIR,MF_ENABLED
				invoke EnableMenuItem,wParam,IDM_NEW_FILE,MF_ENABLED
				invoke EnableMenuItem,wParam,IDM_PACK,MF_ENABLED
				invoke EnableMenuItem,wParam,IDM_EXTRACT,MF_ENABLED
				invoke SendMessage,hWnd,WM_CLOSE,0,0
			.else
				invoke MessageBox,hWnd,"Not allowable name.",addr AppName,MB_OK or MB_ICONHAND
			.endif
		.elseif rdx==host_wnd.hCancel[rax]
			invoke SendMessage,hWnd,WM_CLOSE,0,0
		.endif
	.else
		.if edx==WM_CLOSE
			invoke GetProp,hWnd,addr hostwnd
			invoke HeapFree,hHeap,0,rax
		.endif
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif
	return(NULL)
InputWndProc endp
CreateRootDir proc <4> hEdit:HWND,hBase:HDBASE
LOCAL RootDirName[MAX_PATH]:CHAR
	mov hEdit,rcx
	mov hBase,rdx
	invoke SendMessage,hEdit,WM_GETTEXT,sizeof RootDirName,addr RootDirName
	lea rdx,RootDirName
	.goto Error .if bptr [rdx]==0
	.while TRUE
		mov al,[rdx]
		inc rdx
		.break .if ~al
		.goto Error .if al=='\'
		.goto Error .if al=='/'
	.endw
	invoke NewDirectory,hBase,0,0,0,addr RootDirName
Exit:
	ret
Error:
	xor eax,eax
	jmp Exit
CreateRootDir endp
PutInputCtrls proc <12> uses rsi hWnd:HWND,hostw:LPHOST_WND
	mov hWnd,rcx
	mov rsi,rdx
	invoke CreateWindowEx,0,button,"OK",WS_VISIBLE or WS_CHILD,500,40,65,24,hWnd,0,hInstance,0
	mov host_wnd.hOK[rsi],rax
	invoke SendMessage,rax,WM_SETFONT,hCourier,TRUE
	invoke CreateWindowEx,0,button,"Cancel",WS_VISIBLE or WS_CHILD,580,40,65,24,hWnd,0,hInstance,0
	mov host_wnd.hCancel[rsi],rax
	invoke SendMessage,rax,WM_SETFONT,hCourier,TRUE
	invoke CreateWindowEx,0,edit,"RootDir",WS_VISIBLE or WS_CHILD,5,5,675,24,hWnd,0,hInstance,0
	mov host_wnd.hEdit[rsi],rax
	invoke SendMessage,rax,WM_SETFONT,hCourier,TRUE
	ret
PutInputCtrls endp
AboutWndProc proc <12> hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	mov hWnd,rcx
	mov uMsg,edx
	mov wParam,r8
	mov lParam,r9
	.if edx==WM_CREATE
		.const
			AboutText LABEL CHAR
			CHAR 'Simple data base explorer.',13,10
			CHAR 'dsmhelp@yandex.ru',13,10
			CHAR 'Vasiliy Sotnikov  2011'
		.code
		invoke CreateWindowEx,0,edit,addr AboutText,WS_VISIBLE or WS_CHILD or ES_MULTILINE or ES_READONLY,\
			100,100,200,200,hWnd,0,hInstance,0
		invoke SendMessage,rax,WM_SETFONT,hCourier,TRUE
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif
	return(NULL)
AboutWndProc endp
MoveCtrls proc <6> hWnd:HWND,hList:HWND,hButton:HWND,hCbo:HWND
LOCAL rect:RECT
	mov hWnd,rcx
	mov hList,rdx
	mov hButton,r8
	mov hCbo,r9
	invoke GetClientRect,hWnd,addr rect
	add rect.top,24
	invoke MoveWindow,hList,rect.left,rect.top,rect.right,rect.bottom,TRUE
	mov edx,rect.right
	sub edx,50
	invoke MoveWindow,hButton,rdx,0,50,24,TRUE
	mov r9d,rect.right
	sub r9d,75+50
	invoke MoveWindow,hCbo,75,0,r9,96,TRUE
	ret
MoveCtrls endp
Names db 'Name',0
Indices db 'Index',0
NameIndices db 'Name Index',0
HostIndices db 'Host Index',0
ObjectSize db 'Object Size',0
ObjType db 'Type',0
CreateColumns proc <4> hList:HWND
LOCAL s_col:LVCOLUMN
	mov hList,rcx
	mov s_col.imask,LVCF_FMT or LVCF_WIDTH or LVCF_TEXT
	mov s_col.fmt,LVCFMT_LEFT
	mov s_col.lx,200
	lea rax,Names
	mov s_col.pszText,rax
	mov s_col.cchTextMax,0
	mov s_col.iSubItem,0
	mov s_col.iImage,0
	mov s_col.iOrder,0
	ListView_InsertColumn(hList,0,addr s_col)
	lea rax,Indices
	mov s_col.pszText,rax
	mov s_col.iOrder,1
	mov s_col.lx,150
	ListView_InsertColumn(hList,1,addr s_col)
	lea rax,NameIndices
	mov s_col.pszText,rax
	mov s_col.iOrder,2
	mov s_col.lx,150
	ListView_InsertColumn(hList,2,addr s_col)
	lea rax,HostIndices
	mov s_col.pszText,rax
	mov s_col.iOrder,3
	mov s_col.lx,150
	ListView_InsertColumn(hList,3,addr s_col)
	lea rax,ObjectSize
	mov s_col.pszText,rax
	mov s_col.iOrder,4
	mov s_col.lx,150
	ListView_InsertColumn(hList,4,addr s_col)
	lea rax,ObjType
	mov s_col.pszText,rax
	mov s_col.iOrder,5
	mov s_col.lx,50
	ListView_InsertColumn(hList,5,addr s_col)
	ret
CreateColumns endp
CurrDir db 'Current directory',0
FillListView proc <4> uses rbx rsi rdi r12 hList:HWND,hCbo:HWND,hBase:HDBASE,DirIndex:ULONG64
LOCAL item:LVITEM,root_ind:INDEX,obj_ind:INDEX,str_ind:STR_INDEX
LOCAL obj_name[128]:CHAR
LOCAL obj_index[64]:CHAR
LOCAL obj_name_ind[64]:CHAR
LOCAL obj_host_ind[64]:CHAR
LOCAL obj_size[64]:CHAR
LOCAL obj_type[8]:CHAR
LOCAL FullPath[MAX_PATH]:CHAR
	mov obj_type[4],0
	mov hList,rcx
	mov hCbo,rdx
	mov rbx,r8
	mov rsi,r9
	mov r12,dsmbase.lpBase[rbx]
	.if ~rsi
		mov rsi,BASE_HEADER.RootIndex[r12]
	.endif
	invoke IndexToPath,rbx,rsi,addr FullPath,sizeof FullPath
	.goto ToRet .if ~rax
	invoke SendMessage,hCbo,WM_SETTEXT,0,addr FullPath
	mov root_ind.Index,rsi
	invoke GetIndexType,rbx,addr root_ind
	.goto Error .if eax~=DIR_TYPE && eax~=FILE_TYPE
	invoke SetProp,hList,addr CurrDir,rsi
	ListView_DeleteAllItems(hList)
	mov rsi,root_ind.BaseOffset
	add rsi,r12
	mov rdi,root_ind.FileSize
	shr rdi,3
	mov item.imask,LVIF_TEXT
	mov item.iItem,0
	mov item.iSubItem,0
	mov item.state,0
	mov item.stateMask,0
	mov item.cchTextMax,0
	mov item.iImage,0
	mov item.lParam,0
	mov item.iIndent,0
	mov item.iGroupId,0
	mov item.cColumns,0
	mov item.puColumns,0
	mov item.piColFmt,0
	mov item.iGroup,0
	mov rax,root_ind.HostInd
	.if rax
		mov dptr obj_type,'riD'
		mov dptr obj_name,'...'
		mov obj_ind.Index,rax
		invoke GetIndexType,rbx,addr obj_ind
		invoke IntToStr,addr obj_index,addr obj_ind.Index,10,STD_DEC
		invoke IntToStr,addr obj_name_ind,addr obj_ind.NameInd,10,STD_DEC
		invoke IntToStr,addr obj_host_ind,addr obj_ind.HostInd,10,STD_DEC
		invoke IntToStr,addr obj_size,addr obj_ind.FileSize,10,STD_DEC
		lea rax,obj_name
		mov item.pszText,rax
		ListView_InsertItem(hList,addr item)
		lea rax,obj_index
		mov item.pszText,rax
		inc item.iSubItem
		ListView_SetItem(hList,addr item)
		lea rax,obj_name_ind
		mov item.pszText,rax
		inc item.iSubItem
		ListView_SetItem(hList,addr item)
		
		lea rax,obj_host_ind
		mov item.pszText,rax
		inc item.iSubItem
		ListView_SetItem(hList,addr item)
		
		lea rax,obj_size
		mov item.pszText,rax
		inc item.iSubItem
		ListView_SetItem(hList,addr item)
		lea rax,obj_type
		mov item.pszText,rax
		inc item.iSubItem
		ListView_SetItem(hList,addr item)
		mov item.iSubItem,0
		inc item.iItem
	.endif
	.goto Exit .if ~rdi
	.repeat
		mov rax,[rsi]
		mov obj_ind.Index,rax
		invoke GetIndexType,rbx,addr obj_ind
		.if eax==DIR_TYPE
			mov dptr obj_type,'riD'
		.elseif eax==FILE_TYPE
			mov dptr obj_type,'eliF'
		.endif
		mov rax,obj_ind.NameInd
		mov str_ind.Index,rax
		invoke GetString,rbx,addr str_ind,addr obj_name,sizeof obj_name
		invoke IntToStr,addr obj_index,addr obj_ind.Index,10,STD_DEC
		invoke IntToStr,addr obj_name_ind,addr obj_ind.NameInd,10,STD_DEC
		invoke IntToStr,addr obj_host_ind,addr obj_ind.HostInd,10,STD_DEC
		invoke IntToStr,addr obj_size,addr obj_ind.FileSize,10,STD_DEC
		lea rax,obj_name
		mov item.pszText,rax
		ListView_InsertItem(hList,addr item)
		lea rax,obj_index
		mov item.pszText,rax
		inc item.iSubItem
		ListView_SetItem(hList,addr item)
		lea rax,obj_name_ind
		mov item.pszText,rax
		inc item.iSubItem
		ListView_SetItem(hList,addr item)
		
		lea rax,obj_host_ind
		mov item.pszText,rax
		inc item.iSubItem
		ListView_SetItem(hList,addr item)
		
		lea rax,obj_size
		mov item.pszText,rax
		inc item.iSubItem
		ListView_SetItem(hList,addr item)
		lea rax,obj_type
		mov item.pszText,rax
		inc item.iSubItem
		ListView_SetItem(hList,addr item)
		mov item.iSubItem,0
		inc item.iItem
		add rsi,8
		dec rdi
	.until ZERO?
Exit:
	mov eax,TRUE
ToRet:
	ret
Error:
	xor eax,eax
	jmp ToRet
FillListView endp
AddToList proc <4> uses rbx rsi rdi r12 hList:HWND,hCbo:HWND,hBase:HDBASE,DirIndex:ULONG64
LOCAL item:LVITEM,obj_ind:INDEX,str_ind:STR_INDEX
LOCAL obj_name[128]:CHAR
LOCAL obj_index[64]:CHAR
LOCAL obj_name_ind[64]:CHAR
LOCAL obj_host_ind[64]:CHAR
LOCAL obj_size[64]:CHAR
LOCAL obj_type[8]:CHAR
	mov obj_type[4],0
	mov hList,rcx
	mov hCbo,rdx
	mov rbx,r8
	mov rsi,r9
	mov r12,dsmbase.lpBase[rbx]
	.goto Error .if ~rsi
	mov obj_ind.Index,rsi
	invoke GetIndexType,rbx,addr obj_ind
	.if eax==DIR_TYPE
		mov dptr obj_type,'riD'
	.elseif eax==FILE_TYPE
		mov dptr obj_type,'eliF'
	.endif
	.goto Error .if eax~=DIR_TYPE && eax~=FILE_TYPE
	ListView_GetItemCount(hList)
	mov item.imask,LVIF_TEXT
	mov item.iItem,eax
	mov item.iSubItem,0
	mov item.state,0
	mov item.stateMask,0
	mov item.cchTextMax,0
	mov item.iImage,0
	mov item.lParam,0
	mov item.iIndent,0
	mov item.iGroupId,0
	mov item.cColumns,0
	mov item.puColumns,0
	mov item.piColFmt,0
	mov item.iGroup,0
	
	mov rax,obj_ind.NameInd
	mov str_ind.Index,rax
	invoke GetString,rbx,addr str_ind,addr obj_name,sizeof obj_name
	invoke IntToStr,addr obj_index,addr obj_ind.Index,10,STD_DEC
	invoke IntToStr,addr obj_name_ind,addr obj_ind.NameInd,10,STD_DEC
	invoke IntToStr,addr obj_host_ind,addr obj_ind.HostInd,10,STD_DEC
	invoke IntToStr,addr obj_size,addr obj_ind.FileSize,10,STD_DEC
	lea rax,obj_name
	mov item.pszText,rax
	ListView_InsertItem(hList,addr item)
	lea rax,obj_index
	mov item.pszText,rax
	inc item.iSubItem
	ListView_SetItem(hList,addr item)
	lea rax,obj_name_ind
	mov item.pszText,rax
	inc item.iSubItem
	ListView_SetItem(hList,addr item)
	
	lea rax,obj_host_ind
	mov item.pszText,rax
	inc item.iSubItem
	ListView_SetItem(hList,addr item)
	
	lea rax,obj_size
	mov item.pszText,rax
	inc item.iSubItem
	ListView_SetItem(hList,addr item)
	lea rax,obj_type
	mov item.pszText,rax
	inc item.iSubItem
	ListView_SetItem(hList,addr item)
	mov item.iSubItem,0
	inc item.iItem

Exit:
	mov eax,TRUE
ToRet:
	ret
Error:
	xor eax,eax
	jmp ToRet
AddToList endp
ViewDirContent proc <4> uses rbx rsi rdi r12 hList:HWND,hCbo:HWND,hBase:HDBASE,ItemIndex:SDWORD
LOCAL item:LVITEM
LOCAL obj_index[64]:CHAR,objIndex:ULONG64
	mov hList,rcx
	mov rbx,r8
	mov r12,dsmbase.lpBase[rbx]
	mov hCbo,rdx
	mov item.imask,LVIF_TEXT
	mov item.iItem,r9d
	mov item.iSubItem,5
	mov item.state,0
	mov item.stateMask,0
	lea rax,obj_index
	mov item.pszText,rax
	mov item.cchTextMax,sizeof obj_index
	mov item.iImage,0
	mov item.lParam,0
	mov item.iIndent,0
	mov item.iGroupId,0
	mov item.cColumns,0
	mov item.puColumns,0
	mov item.piColFmt,0
	mov item.iGroup,0
	ListView_GetItem(hList,addr item)
	.if dptr obj_index=='riD'
		mov item.iSubItem,1
		ListView_GetItem(hList,addr item)
		invoke StrToInt,addr objIndex,addr obj_index,10,STD_MASM_NUM
		invoke FillListView,hList,hCbo,rbx,objIndex
	.elseif dptr obj_index=='eliF' && obj_index[4]==0
		
	.endif
	ret
ViewDirContent endp
end